	/*164:*/
	#line 4814 "hitex.w"

#include <stdio.h>
#include <kpathsea/kpathsea.h>
#include "basetypes.h"
#include "error.h"
#include "hformat.h"
#include "textypes.h"
#include "texvars.h"
#include "texfuncs.h"
#include "hput.h"
#include "tltex.h"
#include "hitex.h"

extern scaled hhsize,hvsize;

	/*69:*/
	#line 2711 "hitex.w"

#define RESIZE(P,S,T)       \
{ int _n =  (S)*1.4142136 +0.5;        \
  if (_n<32) _n= 32;                   \
  { REALLOCATE(P,_n,T);             \
    memset((P)+(S),0,(_n-(S))*sizeof(T));         \
    (S)= _n;                           \
  }                                   \
}
	/*:69*/	/*80:*/
	#line 2963 "hitex.w"

#define HPUTDEF(F,R)            \
  { uint32_t _p;                \
    uint8_t _t;                 \
    HPUTNODE;     \
    _p= hpos-hstart;             \
    HPUT8(0);          \
    HPUT8(R);    \
    _t= F;                       \
    hstart[_p]= _t; DBGTAG(_t,hstart+_p);      \
    DBGTAG(_t,hpos); HPUT8(_t); \
  }
	/*:80*/	/*122:*/
	#line 3800 "hitex.w"


#define HPUTCONTENT(F,D)        \
  { uint8_t *_p;                \
    uint8_t _t;                 \
    HPUTNODE;     \
    _p= hpos++;         \
    _t= F(D);                    \
    *_p= _t; DBGTAG(_t,_p);      \
    DBGTAG(_t,hpos); HPUT8(_t); \
  }
	/*:122*/
	#line 4829 "hitex.w"

	/*52:*/
	#line 1902 "hitex.w"

static scaled page_h,page_v;
	/*:52*/	/*56:*/
	#line 2366 "hitex.w"

int insert2stream[0x100]= {0};
	/*:56*/	/*70:*/
	#line 2722 "hitex.w"

static int dir_entries= 4;
	/*:70*/	/*76:*/
	#line 2871 "hitex.w"

static int32_t int_defined[0x100]= {0};
	/*:76*/	/*77:*/
	#line 2881 "hitex.w"

static const int hmap_int[]= {
pretolerance_no,
tolerance_no,
line_penalty_no,
hyphen_penalty_no,
ex_hyphen_penalty_no,
club_penalty_no,
widow_penalty_no,
display_widow_penalty_no,
broken_penalty_no,
-1,
-1,
pre_display_penalty_no,
post_display_penalty_no,
inter_line_penalty_no,
double_hyphen_demerits_no,
final_hyphen_demerits_no,
adj_demerits_no,
-1,
-1,
looseness_no,
time_no,
day_no,
month_no,
year_no,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
hang_after_no,
floating_penalty_no
};


	/*:77*/	/*82:*/
	#line 2992 "hitex.w"

static scaled dimen_defined[0x100]= {0};
	/*:82*/	/*83:*/
	#line 2996 "hitex.w"

static const int hmap_dimen[]= {
-1,
-1,
line_skip_limit_no,
hsize_dimen_no,
vsize_dimen_no,
max_depth_no,
split_max_depth_no,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
hang_indent_no,
-1,
-1,
emergency_stretch_no
};
	/*:83*/	/*87:*/
	#line 3065 "hitex.w"

static struct{
scaled w,h,v;}xdimen_defined[0x100];
	/*:87*/	/*93:*/
	#line 3151 "hitex.w"

static pointer glue_defined[0x100];
	/*:93*/	/*94:*/
	#line 3155 "hitex.w"

static int hmap_glue[]= {

line_skip_no,
baseline_skip_no,
-1,
above_display_skip_no,
below_display_skip_no,
above_display_short_skip_no,
below_display_short_skip_no,
left_skip_no,
right_skip_no,
top_skip_no,
split_top_skip_no,
tab_skip_no,
-1,
-1,
par_fill_skip_no
};
	/*:94*/	/*100:*/
	#line 3275 "hitex.w"

typedef struct{
pointer ls,bs;
scaled lsl;
}bl_defined_t;

static bl_defined_t*bl_defined= NULL;
static int bl_used= 0,bl_allocated= 0;
	/*:100*/	/*106:*/
	#line 3401 "hitex.w"

static pointer hy_defined[0x100];
	/*:106*/	/*111:*/
	#line 3483 "hitex.w"


#define PLH_SIZE 313 

struct{int l;
uint32_t h;
uint32_t n;
uint32_t s;
uint8_t*p;}pl_defined[PLH_SIZE]= {{0}};
int pl_head= -1,*pl_tail= &pl_head;
	/*:111*/	/*115:*/
	#line 3617 "hitex.w"

#define MAX_FONTS 0x100

typedef struct{
uint8_t i;
pointer g;
pointer h;
pointer p[MAX_FONT_PARAMS];
uint16_t m;
uint16_t y;
}font_t;

static font_t*hfonts[MAX_FONTS]= {NULL};
static int hmap_font[MAX_FONTS];
	/*:115*/	/*132:*/
	#line 4010 "hitex.w"

static struct{
uint8_t n;
str_number s;
}hlanguage[0x100];
	/*:132*/
	#line 4830 "hitex.w"

	/*42:*/
	#line 1524 "hitex.w"

static bool set_image_dimensions(pointer p,double w,double h,bool absolute)
{if(image_width(p)!=0)
{double aspect= h/w;
image_height(p)= round(image_width(p)*aspect);
}
else if(image_height(p)!=0)
{double aspect= w/h;
image_width(p)= round(image_height(p)*aspect);
}
else
{if(!absolute)return false;
image_width(p)= round(unity*w);
image_height(p)= round(unity*h);
}
return true;
}
	/*:42*/	/*43:*/
	#line 1544 "hitex.w"

#define IMG_BUF_MAX 54
#define IMG_HEAD_MAX 2
static unsigned char img_buf[IMG_BUF_MAX];
static int img_buf_size;
#define LittleEndian32(X)   (img_buf[(X)]+(img_buf[(X)+1]<<8)+\
                                (img_buf[(X)+2]<<16)+(img_buf[(X)+3]<<24))

#define BigEndian16(X)   (img_buf[(X)+1]+(img_buf[(X)]<<8))

#define BigEndian32(X)   (img_buf[(X)+3]+(img_buf[(X)+2]<<8)+\
                                (img_buf[(X)+1]<<16)+(img_buf[(X)]<<24))

#define Match2(X,A,B)  ((img_buf[(X)]==(A)) && (img_buf[(X)+1]==(B)))
#define Match4(X,A,B,C,D)  (Match2(X,A,B)&&Match2((X)+2,C,D))

#define GET_IMG_BUF(X) \
if (img_buf_size<X) \
  { int i= fread(img_buf+img_buf_size,1,(X)-img_buf_size,f); \
    if (i<0) QUIT("Unable to read image %s",fn); \
    else if (i==0) QUIT("Unable to read image header %s",fn); \
    else img_buf_size+= i; \
  }
	/*:43*/	/*44:*/
	#line 1583 "hitex.w"

static bool get_BMP_info(FILE*f,char*fn,pointer p)
{double w,h;
double xppm,yppm;
GET_IMG_BUF(2);
if(!Match2(0,'B','M'))return false;
GET_IMG_BUF(0x2E);
w= (double)LittleEndian32(0x12);
h= (double)LittleEndian32(0x16);
xppm= (double)LittleEndian32(0x26);
yppm= (double)LittleEndian32(0x2A);
return set_image_dimensions(p,(72.27*1000.0/25.4)*w/xppm,(72.27*1000.0/25.4)*h/yppm,true);
}
	/*:44*/	/*45:*/
	#line 1621 "hitex.w"


static bool get_PNG_info(FILE*f,char*fn,pointer p)
{int pos,size;
double w,h;
double xppu,yppu;
int unit;
GET_IMG_BUF(24);
if(!Match4(0,0x89,'P','N','G')||
!Match4(4,0x0D,0x0A,0x1A,0x0A))return false;
size= BigEndian32(8);
if(!Match4(12,'I','H','D','R'))return false;
w= (double)BigEndian32(16);
h= (double)BigEndian32(20);
pos= 20+size;
while(true)
{if(fseek(f,pos,SEEK_SET)!=0)return false;
img_buf_size= 0;
GET_IMG_BUF(17);
size= BigEndian32(0);
if(Match4(4,'p','H','Y','s'))
{xppu= (double)BigEndian32(8);
yppu= (double)BigEndian32(12);
unit= img_buf[16];
if(unit==0)
return set_image_dimensions(p,w/xppu,h/yppu,false);
else if(unit==1)
return set_image_dimensions(p,(72.27/0.0254)*w/xppu,(72.27/0.0254)*h/yppu,true);
else
return false;
}
else if(Match4(4,'I','D','A','T'))
return set_image_dimensions(p,w,h,false);
else
pos= pos+12+size;
}
return false;
}
	/*:45*/	/*46:*/
	#line 1675 "hitex.w"


static bool get_JPG_info(FILE*f,char*fn,pointer p)
{int pos,size;
double w,h;
double xppu,yppu;
int unit;
GET_IMG_BUF(18);

if(!Match4(0,0xFF,0xD8,0xFF,0xE0))return false;
size= BigEndian16(4);
if(!Match4(6,'J','F','I','F'))return false;
if(img_buf[10]!=0)return false;
unit= img_buf[13];
xppu= (double)BigEndian16(14);
yppu= (double)BigEndian16(16);
pos= 4+size;
while(true)
{if(fseek(f,pos,SEEK_SET)!=0)return false;
img_buf_size= 0;
GET_IMG_BUF(10);
if(img_buf[0]!=0xFF)return false;
if((img_buf[1]&0xF0)==0xC0)
{h= (double)BigEndian16(5);
w= (double)BigEndian16(7);
if(unit==0)
return set_image_dimensions(p,w/xppu,h/yppu,false);
else if(unit==1)
return set_image_dimensions(p,72.27*w/xppu,72.27*h/yppu,true);
else if(unit==2)
return set_image_dimensions(p,(72.27/2.54)*w/xppu,(72.27/2.54)*h/yppu,true);
else
return false;
}
else
{size= BigEndian16(2);
pos= pos+2+size;
}
}
return false;
}
	/*:46*/	/*50:*/
	#line 1835 "hitex.w"

static bool is_visible(pointer p)
{switch(type(p))
{case penalty_node:
case kern_node:
case glue_node:
case mark_node:
return false;
case hlist_node:
case vlist_node:
return list_ptr(p)!=null;
case whatsit_node:
if(subtype(p)==image_node||subtype(p)==align_node||subtype(p)==disp_node)
return true;
else if(subtype(p)==hset_node||subtype(p)==vset_node||
subtype(p)==hpack_node||subtype(p)==vpack_node)
return list_ptr(p)!=null;
else if(subtype(p)==graf_node)
return graf_list(p)!=null;
else
return false;
default:return true;
}
}
	/*:50*/	/*64:*/
	#line 2618 "hitex.w"


static pointer hget_current_page(void)
{pointer p= link(setpage_head);
if(p==null)
print_err("end of output group without setpage node");
return p;
}

static pointer hget_current_stream(void)
{pointer p,s;
p= hget_current_page();
if(p==null)return null;
s= setpage_streams(p);
if(s==null)
print_err("end of setstream group without setstream node");
return s;
}
	/*:64*/	/*71:*/
	#line 2726 "hitex.w"

static uint16_t hnew_file_section(char*file_name)
{uint16_t i;
	/*67:*/
	#line 2694 "hitex.w"

for(i= 3;i<=max_section_no;i++)
if(dir[i].file_name!=NULL&&strcmp(dir[i].file_name,file_name)==0)
return i;
	/*:67*/
	#line 2729 "hitex.w"

	/*68:*/
	#line 2700 "hitex.w"

i= max_section_no;
i++;
if(i>0xFFFF)QUIT("Too many file sections");
if(i>=dir_entries)
RESIZE(dir,dir_entries,entry_t);
max_section_no= i;
if(max_section_no>0xFFFF)QUIT("Too many sections");
dir[i].section_no= i;
	/*:68*/
	#line 2730 "hitex.w"

dir[i].file_name= strdup(file_name);
return i;
}
	/*:71*/	/*72:*/
	#line 2745 "hitex.w"

static char*hfile_name(str_number n,str_number a,str_number e)
{pack_file_name(n,a,e);
if(name_length>=file_name_size)
QUIT("File name too long %d >= %d",name_length,file_name_size);
return(char*)name_of_file+1;
}

	/*:72*/	/*79:*/
	#line 2945 "hitex.w"

static int hget_int_no(int32_t n)
{int i;
int m= max_ref[int_kind];
for(i= 0;i<=m;i++)
if(n==int_defined[i])return i;
if(m<0xFF&&section_no==2)
{m= ++max_ref[int_kind];int_defined[m]= n;return m;}
else
return-1;
}
	/*:79*/	/*85:*/
	#line 3035 "hitex.w"

static int hget_dimen_no(scaled s)


{int i;
int m= max_ref[dimen_kind];
for(i= 0;i<=m;i++)
if(s==dimen_defined[i])return i;
if(m<0xFF&&section_no==2)
{m= ++max_ref[dimen_kind];dimen_defined[m]= s;return m;}
else
return-1;
}
	/*:85*/	/*89:*/
	#line 3087 "hitex.w"

int hget_xdimen_no(pointer p)
{int i;
for(i= 0;i<=max_ref[xdimen_kind];i++)
{if(xdimen_defined[i].w==xdimen_width(p)&&
xdimen_defined[i].h==xdimen_hfactor(p)&&
xdimen_defined[i].v==xdimen_vfactor(p))
return i;
}
if(section_no!=2)return-1;
if(i>=0x100)return-1;
max_ref[xdimen_kind]= i;
xdimen_defined[i].w= xdimen_width(p);
xdimen_defined[i].h= xdimen_hfactor(p);
xdimen_defined[i].v= xdimen_vfactor(p);
return i;
}
	/*:89*/	/*96:*/
	#line 3188 "hitex.w"

int glue_spec_equal(pointer p,pointer q)
{return(width(q)==width(p)&&stretch(q)==stretch(p)&&shrink(q)==shrink(p)&&
(stretch_order(q)==stretch_order(p)||stretch(q)==0)&&
(shrink_order(q)==shrink_order(p)||shrink(q)==0));
}

int glue_equal(pointer p,pointer q)
{return p==q||glue_spec_equal(p,q);
}

int glue_t_equal(glue_t*p,glue_t*q)
{return(p->w.w==q->w.w&&p->w.h==q->w.h&&p->w.v==q->w.v&&
p->p.f==q->p.f&&p->m.f==q->m.f&&
(p->p.o==q->p.o||p->p.f==0.0)&&
(p->m.o==q->m.o||q->m.f==0.0));
}

	/*:96*/	/*99:*/
	#line 3261 "hitex.w"

void to_glue_t(pointer p,glue_t*g)
{g->w.w= width(p);
g->w.h= g->w.v= 0.0;
g->p.f= stretch(p)/(double)ONE;g->p.o= stretch_order(p);
g->m.f= shrink(p)/(double)ONE;g->m.o= shrink_order(p);
}
	/*:99*/	/*103:*/
	#line 3334 "hitex.w"


uint8_t hout_baselinespec(int n)
{info_t i= b000;
pointer p;
scaled s;
p= bl_defined[n].bs;
if(p!=zero_glue)
{uint8_t*pos;
uint8_t tag;
HPUTNODE;
pos= hpos;
hpos++;
tag= hout_glue_spec(p);
*pos= tag;DBGTAG(tag,pos);
DBGTAG(tag,hpos);HPUT8(tag);
i|= b100;
}
p= bl_defined[n].ls;
if(p!=zero_glue)
{uint8_t*pos;
uint8_t tag;
HPUTNODE;
pos= hpos;
hpos++;
tag= hout_glue_spec(p);
*pos= tag;DBGTAG(tag,pos);
DBGTAG(tag,hpos);HPUT8(tag);
i|= b010;
}
s= bl_defined[n].lsl;
if(s!=0){HPUT32(s);i|= b001;}
return TAG(baseline_kind,i);
}
	/*:103*/	/*107:*/
	#line 3408 "hitex.w"

static bool list_equal(pointer p,pointer q)

{while(true)
if(p==q)return true;
else if(p==null||q==null)return false;
else if(is_char_node(p)&&is_char_node(q)&&
font(p)==font(q)&&character(p)==character(q))
{p= link(p);q= link(q);}
else return false;
}

static pointer copy_disc_node(pointer p)
{pointer q;
q= get_node(small_node_size);
pre_break(q)= copy_node_list(pre_break(p));
post_break(q)= copy_node_list(post_break(p));
type(q)= type(p);
subtype(q)= subtype(p);
return q;
}
	/*:107*/	/*117:*/
	#line 3647 "hitex.w"

static pointer find_space_glue(internal_font_number f)
{main_p= font_glue[f];
if(main_p==null)
{main_p= new_spec(zero_glue);main_k= param_base[f]+space_code;
width(main_p)= font_info[main_k].sc;
stretch(main_p)= font_info[main_k+1].sc;
shrink(main_p)= font_info[main_k+2].sc;
font_glue[f]= main_p;
}
return main_p;
}
static pointer hget_font_space(uint8_t f)
{pointer p;
if(space_skip==zero_glue)
p= find_space_glue(f);
else
p= glue_par(space_skip_code);
add_glue_ref(p);
return p;
}


static pointer hget_font_hyphen(uint8_t f)
{pointer p;
int c;
p= new_disc();
c= hyphen_char[f];
if(c>=0&&c<256)pre_break(p)= new_character(f,c);
return p;
}


static void hdef_font_params(pointer p[MAX_FONT_PARAMS])
{
}
	/*:117*/	/*118:*/
	#line 3693 "hitex.w"

static uint8_t hget_font_no(uint8_t f)

{int g;
char*n,*fn;
int l;
if(f==0)
{DBG(DBGFONT,"TeX nullfont -> 0\n");
return 0;
}
g= hmap_font[f];
DBG(DBGFONT,"Mapping TeX font %d->%d\n",f,g);
if(g>=0)return g;
DBG(DBGDEF,"New TeX font %d\n",f);
if(max_ref[font_kind]>=0x100)
QUIT("too many fonts in use");
g= ++(max_ref[font_kind]);
ALLOCATE(hfonts[g],1,font_t);
hfonts[g]->i= f;
hmap_font[f]= g;
hfonts[g]->g= hget_font_space(f);
hfonts[g]->h= hget_font_hyphen(f);
fn= hfile_name(font_name[f],empty_string,empty_string);
n= tl_find_tfm(fn);
hfonts[g]->m= hnew_file_section(n);
free(n);
n= tl_find_glyph(fn);
hfonts[g]->y= hnew_file_section(n);
free(n);
return g;
}
	/*:118*/	/*119:*/
	#line 3733 "hitex.w"

static void ensure_font_no(pointer p)
{while(p!=null)
{if(is_char_node(p))
hget_font_no(font(p));
else if(type(p)==hlist_node||type(p)==vlist_node)
ensure_font_no(list_ptr(p));
p= link(p);
}
}
	/*:119*/	/*121:*/
	#line 3773 "hitex.w"


void hout_string(int s)
{pool_pointer j;
uint8_t c;
j= str_start[s];
while(j<str_start[s+1])
{c= so(str_pool[j++]);
if(c=='%'||c<0x20||c>=0x7F)
{char str[4];
snprintf(str,4,"%%%02X",c);
HPUTX(3);
HPUT8(str[0]);HPUT8(str[1]);HPUT8(str[2]);
}
else
{HPUTX(1);
HPUT8(c);
}
}
HPUT8(0);
}
	/*:121*/	/*131:*/
	#line 3990 "hitex.w"

void hout_xdimen_node(pointer p)
{xdimen_t x;
x.w= xdimen_width(p);
x.h= xdimen_hfactor(p)/(double)ONE;
x.v= xdimen_vfactor(p)/(double)ONE;
hput_xdimen_node(&x);
}
bool hout_xdimen(pointer p)
{int n= hget_xdimen_no(p);
if(n>=0){HPUT8(n);return false;}
else
{hout_xdimen_node(p);return true;}
}

	/*:131*/	/*133:*/
	#line 4023 "hitex.w"

uint8_t hget_language_no(uint8_t n)
{int i;
for(i= 0;i<=max_ref[language_kind];i++)
if(hlanguage[i].n==n)return i;
i= ++max_ref[language_kind];
hlanguage[i].n= n;
hlanguage[i].s= 0;
return i;
}

uint8_t hout_language(uint8_t n)
{n= hget_language_no(n);
if(n<7)return TAG(language_kind,n+1);
else
{HPUT8(n);return TAG(language_kind,0);}
}
	/*:133*/	/*138:*/
	#line 4125 "hitex.w"


static uint8_t hout_glue_spec(pointer p)
{glue_t g;
to_glue_t(p,&g);
return hput_glue(&g);
}

static uint8_t hout_glue(pointer p)
{int n;
n= hget_glue_no(p);
if(n<0)
return hout_glue_spec(p);
else
{HPUT8(n);return TAG(glue_kind,0);}
}

static void hout_glue_node(pointer p)
{uint8_t*pos;
uint8_t tag;
HPUTNODE;
pos= hpos;
hpos++;
tag= hout_glue(p);
*pos= tag;DBGTAG(tag,pos);
DBGTAG(tag,hpos);HPUT8(tag);
}
	/*:138*/	/*140:*/
	#line 4175 "hitex.w"


uint8_t hout_hyphen(pointer p)
{hyphen_t h;
h.x= !is_auto_disc(p);
if(pre_break(p)==null)
h.p.s= 0;
else
{uint32_t lpos;
lpos= hpos-hstart;
h.p.k= list_kind;
hout_list_node(pre_break(p),lpos,&(h.p));
}
if(post_break(p)==null)
h.q.s= 0;
else
{uint32_t lpos;
lpos= hpos-hstart;
h.q.k= list_kind;
hout_list_node(post_break(p),lpos,&(h.q));
}
h.r= replace_count(p);
return hput_hyphen(&h);
}

	/*:140*/	/*157:*/
	#line 4474 "hitex.w"

void hout_preamble(pointer p)
{pointer q,r;
DBG(DBGBASIC,"Writing Preamble\n");
q= p;
if(q!=null)r= link(q);else r= null;
while(r!=null)
{if(type(r)==unset_node)
{link(q)= link(r);
link(r)= null;flush_node_list(r);
}
else
q= r;
r= link(q);
}
hout_list_node2(p);
DBG(DBGBASIC,"End Preamble\n");
}
	/*:157*/	/*158:*/
	#line 4499 "hitex.w"


static void hout_item(pointer p,uint8_t t,uint8_t s)
{info_t i= b000;
uint8_t n;
n= span_count(p)+1;
DBG(DBGBASIC,"Writing Item %d/%d->%d/%d\n",type(p),n,t,s);
display_node(p);
if(n==0)QUIT("Span count of item must be positive");
if(n<7)i= n;else i= 7;
HPUTTAG(item_kind,i);
type(p)= t;subtype(p)= s;
hout_node(p);
if(i==7)HPUT8(n);
HPUTTAG(item_kind,i);
DBG(DBGBASIC,"End Item\n");
}


static void hout_item_list(pointer p,bool v)
{list_t l;
uint32_t pos;
DBG(DBGBASIC,"Writing Item List\n");
l.k= list_kind;
HPUTTAG(item_kind,b000);
pos= hpos-hstart;
HPUTX(2);
HPUT8(0);
HPUT8(0);
l.p= hpos-hstart;
while(p>mem_min)
{if(is_char_node(p))hout_node(p);
else if(type(p)==unset_node)hout_item(p,v?vlist_node:hlist_node,0);
else if(type(p)==unset_set_node)hout_item(p,whatsit_node,v?vset_node:hset_node);
else if(type(p)==unset_pack_node)hout_item(p,whatsit_node,v?vpack_node:hpack_node);
else hout_node(p);
p= link(p);
}
l.s= (hpos-hstart)-l.p;
hput_tags(pos,hput_list(pos+1,&l));
HPUTTAG(item_kind,b000);
DBG(DBGBASIC,"End Item List\n");
}

void hout_align_list(pointer p,bool v)
{list_t l;
uint32_t pos;
DBG(DBGBASIC,"Writing Align List\n");
l.k= list_kind;
pos= hpos-hstart;
HPUTX(2);
HPUT8(0);
HPUT8(0);
l.p= pos+2;
while(p>mem_min)
{if(!is_char_node(p)&&(type(p)==unset_node||type(p)==unset_set_node||type(p)==unset_pack_node))
hout_item_list(list_ptr(p),v);
else
hout_node(p);
p= link(p);
}
l.s= (hpos-hstart)-l.p;
hput_tags(pos,hput_list(pos+1,&l));
DBG(DBGBASIC,"End Align List\n");
}
	/*:158*/
	#line 4831 "hitex.w"


	/*35:*/
	#line 1025 "hitex.w"

pointer new_graf_node(void)
{pointer p;
p= get_node(graf_node_size);
type(p)= whatsit_node;
subtype(p)= graf_node;
graf_params(p)= null;
graf_list(p)= null;
return p;
}


pointer new_disp_node(void)
{pointer p;
p= get_node(disp_node_size);
type(p)= whatsit_node;
subtype(p)= disp_node;
display_params(p)= null;
display_formula(p)= null;
display_eqno(p)= null;
return p;
}

pointer new_baseline_node(pointer bs,pointer ls,scaled lsl)
{pointer p;
p= get_node(baseline_node_size);
type(p)= whatsit_node;
subtype(p)= baseline_node;
baseline_node_no(p)= hget_baseline_no(bs,ls,lsl);
return p;
}

pointer new_pack_node(void)
{pointer p;
p= get_node(pack_node_size);
type(p)= whatsit_node;
subtype(p)= hpack_node;
width(p)= depth(p)= height(p)= shift_amount(p)= 0;
pack_limit(p)= max_dimen;
list_ptr(p)= null;
return p;
}
pointer new_set_node(void)
{pointer p;
p= get_node(set_node_size);
type(p)= whatsit_node;
subtype(p)= hset_node;
width(p)= depth(p)= height(p)= shift_amount(p)= set_stretch(p)= set_shrink(p)= set_extent(p)= 0;
list_ptr(p)= null;
return p;
}


pointer new_image_node(str_number n,str_number a,str_number e)
{pointer p;
int i;
char*fn;
int l;

p= get_node(image_node_size);type(p)= whatsit_node;subtype(p)= image_node;
image_name(p)= n;
image_area(p)= a;
image_ext(p)= e;
fn= hfile_name(n,a,e);
l= strlen(fn);
if(l>=file_name_size)QUIT("Filename of image file too long");
i= hnew_file_section(fn);
image_no(p)= i;
image_width(p)= image_height(p)= image_stretch(p)= image_shrink(p)= 0;
image_shrink_order(p)= image_stretch_order(p)= normal;
return p;
}


	/*:35*/	/*38:*/
	#line 1123 "hitex.w"

void add_par_node(uint8_t t,uint8_t n,int v)
{pointer p;
	/*36:*/
	#line 1104 "hitex.w"

p= get_node(par_node_size);
type(p)= whatsit_node;
subtype(p)= par_node;
par_type(p)= t;
par_number(p)= n;
	/*:36*/
	#line 1126 "hitex.w"

	/*37:*/
	#line 1112 "hitex.w"

if(t==int_type)par_value(p).i= v;
else if(t==dimen_type)par_value(p).sc= v;
else if(t==glue_type)
{par_value(p).i= v;add_glue_ref(par_value(p).i);}
else
{free_node(p,par_node_size);
QUIT("Undefined parameter type %d",t);
}
	/*:37*/
	#line 1127 "hitex.w"

link(p)= link(temp_head);
link(temp_head)= p;
}
	/*:38*/	/*39:*/
	#line 1191 "hitex.w"

void hline_break(int final_widow_penalty)
{bool auto_breaking;
pointer r,s;
pointer pp;
bool par_shape_fix= false;
bool first_word= true;
if(DBGTEX&debugflags)
{print_ln();print_str("Before hline_break:\n");
breadth_max= 200;
depth_threshold= 200;
show_node_list(link(head));print_ln();
}
if(dimen_par_hfactor(hsize_code)==0&&dimen_par_vfactor(hsize_code)==0)
{line_break(final_widow_penalty);
return;
}

pp= new_graf_node();
graf_penalty(pp)= final_widow_penalty;
if(par_shape_ptr==null)
graf_extent(pp)= new_xdimen(dimen_par(hsize_code),
dimen_par_hfactor(hsize_code),dimen_par_vfactor(hsize_code));
else
	/*40:*/
	#line 1355 "hitex.w"

{last_special_line= info(par_shape_ptr)-1;
if(last_special_line!=0)
DBG(DBGTEX,"Warning parshape with n=%d not yet implemented",info(par_shape_ptr));
second_width= mem[par_shape_ptr+2*(last_special_line+1)].sc;
second_indent= mem[par_shape_ptr+2*last_special_line+1].sc;

graf_extent(pp)= new_xdimen(second_indent+second_width,
par_shape_hfactor,par_shape_vfactor);
second_width= second_width+round((double)par_shape_hfactor*hhsize/unity
+(double)par_shape_vfactor*hvsize/unity);
par_shape_fix= true;
}
	/*:40*/
	#line 1215 "hitex.w"

link(temp_head)= link(head);
if(is_char_node(tail))
{tail_append(new_penalty(inf_penalty))
tail_append(new_param_glue(par_fill_skip_code));
}
else if(type(tail)!=whatsit_node||subtype(tail)!=disp_node)
{if(type(tail)!=glue_node)tail_append(new_penalty(inf_penalty))
else
{type(tail)= penalty_node;delete_glue_ref(glue_ptr(tail));
flush_node_list(leader_ptr(tail));penalty(tail)= inf_penalty;
}
link(tail)= new_param_glue(par_fill_skip_code);
}
DBG(DBGTEX,"\nCalling line_break:\n"
"hang_indent=0x%08X hang_after=%d",hang_indent,hang_after);
if(line_skip_limit!=0)
DBG(DBGTEX," line_skip_limit=0x%08X",line_skip_limit);
DBG(DBGTEX," prev_graf=0x%08X",prev_graf);

init_cur_lang= prev_graf%0200000;
init_l_hyf= prev_graf/020000000;
init_r_hyf= (prev_graf/0200000)%0100;
pop_nest();
DBG(DBGTEX," prev_graf=0x%08X",prev_graf);


#ifdef INIT
if(trie_not_ready)init_trie();
#endif
cur_lang= init_cur_lang;l_hyf= init_l_hyf;r_hyf= init_r_hyf;
if(DBGTEX&debugflags)
{print_ln();print_str("Before hyphenation:\n");
breadth_max= 200;
depth_threshold= 200;
show_node_list(link(temp_head));print_ln();
}
auto_breaking= true;
cur_p= temp_head;
if(option_hyphen_first&&is_char_node(link(cur_p)))
{hyphenate_word();first_word= false;}
cur_p= link(cur_p);
while(cur_p!=null)
{
if(is_char_node(cur_p))
{
do{
f= font(cur_p);
cur_p= link(cur_p);
}while(is_char_node(cur_p));
if(cur_p==null)goto done5;
}
switch(type(cur_p))
{case whatsit_node:
adv_past(cur_p);
break;
case glue_node:
if(auto_breaking)
hyphenate_word();
break;
case ligature_node:
f= font(lig_char(cur_p));
break;
case disc_node:

r= replace_count(cur_p);s= link(cur_p);
while(r>0)
{decr(r);s= link(s);
}
cur_p= s;
goto done5;
case math_node:
auto_breaking= (subtype(cur_p)==after);
break;
default:
break;
}
if(option_hyphen_first&&first_word&&is_char_node(link(cur_p)))
{hyphenate_word();first_word= false;}
cur_p= link(cur_p);
done5:;
}
if(DBGTEX&debugflags)
{print_ln();print_str("After hline_break:\n");
breadth_max= 200;
depth_threshold= 200;
show_node_list(link(temp_head));print_ln();
}
graf_list(pp)= link(temp_head);

link(temp_head)= null;

add_par_node(int_type,pretolerance_code,pretolerance);
add_par_node(int_type,tolerance_code,tolerance);
add_par_node(dimen_type,emergency_stretch_code,emergency_stretch);

add_par_node(int_type,line_penalty_code,line_penalty);
add_par_node(int_type,hyphen_penalty_code,hyphen_penalty);
add_par_node(int_type,ex_hyphen_penalty_code,ex_hyphen_penalty);
add_par_node(int_type,club_penalty_code,club_penalty);
add_par_node(int_type,widow_penalty_code,widow_penalty);
add_par_node(int_type,broken_penalty_code,broken_penalty);
add_par_node(int_type,inter_line_penalty_code,inter_line_penalty);
add_par_node(int_type,double_hyphen_demerits_code,double_hyphen_demerits);
add_par_node(int_type,final_hyphen_demerits_code,final_hyphen_demerits);
add_par_node(int_type,adj_demerits_code,adj_demerits);
add_par_node(int_type,looseness_code,looseness);

if(par_shape_fix)
{add_par_node(int_type,hang_after_code,0);
add_par_node(dimen_type,hang_indent_code,second_indent);
}
else
{add_par_node(int_type,hang_after_code,hang_after);
add_par_node(dimen_type,hang_indent_code,hang_indent);
}

add_par_node(dimen_type,line_skip_limit_code,line_skip_limit);
add_par_node(glue_type,line_skip_code,line_skip);
add_par_node(glue_type,baseline_skip_code,baseline_skip);

add_par_node(glue_type,left_skip_code,left_skip);
add_par_node(glue_type,right_skip_code,right_skip);
add_par_node(glue_type,par_fill_skip_code,par_fill_skip);



graf_params(pp)= link(temp_head);
link(temp_head)= null;
append_to_vlist(pp);
}
	/*:39*/	/*41:*/
	#line 1500 "hitex.w"

void hget_image_information(pointer p)
{char*fn;
FILE*f;
if(image_width(p)!=0&&image_height(p)!=0)return;
fn= dir[image_no(p)].file_name;
f= fopen(fn,"rb");
if(f==NULL)QUIT("Unable to open image file %s.",fn);
MESSAGE("(%s",fn);
img_buf_size= 0;
if(!get_BMP_info(f,fn,p)&&!get_PNG_info(f,fn,p)&&!get_JPG_info(f,fn,p))
QUIT("Unable to obtain width and height information for image %s",fn);
fclose(f);
MESSAGE(" width= %fpt height= %fpt)",image_width(p)/(double)ONE,image_height(p)/(double)ONE);
}
	/*:41*/	/*47:*/
	#line 1736 "hitex.w"

void build_page(void)
{static bool initial= true;
if(link(contrib_head)==null)return;
do{pointer p= link(contrib_head);
	/*49:*/
	#line 1805 "hitex.w"

if(option_no_empty_page&&
((type(p)==penalty_node&&
penalty(p)<=eject_penalty&&penalty(p)>2*(eject_penalty))||
(page_contents==empty&&!is_visible(p))))
{pointer q= link(p);
while(true)
{if(q==null)return;
else if(is_visible(q))break;
else if(type(q)==penalty_node&&penalty(q)<=eject_penalty)
{while(p!=q)
{pointer r= p;
DBG(DBGPAGE,"Eliminating node (%d,%d)\n",
type(p),type(p)==penalty_node?penalty(p):subtype(p));
p= link(p);
link(r)= null;
flush_node_list(r);
}
link(contrib_head)= p;
DBG(DBGPAGE,"Eliminating empty page done\n");
if(penalty(q)<=2*(eject_penalty))break;
}
q= link(q);
}
}
	/*:49*/
	#line 1741 "hitex.w"

update_last_values(p);
	/*48:*/
	#line 1756 "hitex.w"

if(page_contents<box_there)
{switch(type(p))
{case whatsit_node:
if(subtype(p)==baseline_node)goto recycle_p;
else if(subtype(p)!=hset_node&&subtype(p)!=vset_node&&
subtype(p)!=hpack_node&&subtype(p)!=vpack_node&&
subtype(p)!=graf_node&&subtype(p)!=disp_node&&
subtype(p)!=image_node&&subtype(p)!=align_node)
break;
case hlist_node:case vlist_node:case rule_node:
if(page_contents==empty)
{freeze_page_specs(box_there);
hfix_defaults();
}
else page_contents= box_there;
break;
case ins_node:
if(page_contents==empty)
{freeze_page_specs(inserts_only);
hfix_defaults();
}
break;
case kern_node:
case penalty_node:
case glue_node:goto recycle_p;
default:
break;
}
}
	/*:48*/
	#line 1743 "hitex.w"

page_goal= 0x7FFF0000;
hout_node(p);
recycle_p:
link(contrib_head)= link(p);link(p)= null;
flush_node_list(p);
}while(link(contrib_head)!=null);
if(nest_ptr==0)tail= contrib_head;
else contrib_tail= contrib_head;
DBG(DBGBUFFER,"after build page dyn_used= %d\n",dyn_used);
}
	/*:47*/	/*54:*/
	#line 1917 "hitex.w"


pointer hpack(pointer p,scaled w,scaled hf,scaled vf,small_number m)
{
pointer r;
pointer prev_p;
scaled h,d,x;
scaled s;
pointer g;
glue_ord sto,sho;
internal_font_number f;
four_quarters i;
eight_bits hd;
last_badness= 0;r= get_node(box_node_size);type(r)= hlist_node;
subtype(r)= min_quarterword;shift_amount(r)= 0;
prev_p= r+list_offset;link(prev_p)= p;
h= 0;d= 0;x= 0;
total_stretch[normal]= 0;total_shrink[normal]= 0;
total_stretch[fil]= 0;total_shrink[fil]= 0;
total_stretch[fill]= 0;total_shrink[fill]= 0;
total_stretch[filll]= 0;total_shrink[filll]= 0;
while(p!=null)
{
reswitch:
while(is_char_node(p))
{f= font(p);i= char_info(f)(character(p));hd= height_depth(i);
x= x+char_width(f)(i);
s= char_height(f)(hd);if(s>h)h= s;
s= char_depth(f)(hd);if(s>d)d= s;
p= link(p);
}
if(p!=null)
{switch(type(p)){
case hlist_node:case vlist_node:case rule_node:case unset_node:
{x= x+width(p);
if(type(p)>=rule_node)s= 0;else s= shift_amount(p);
if(height(p)-s>h)h= height(p)-s;
if(depth(p)+s>d)d= depth(p)+s;
}
break;
case ins_node:case mark_node:case adjust_node:if(adjust_tail!=null)
{while(link(prev_p)!=p)prev_p= link(prev_p);
if(type(p)==adjust_node)
{link(adjust_tail)= adjust_ptr(p);
while(link(adjust_tail)!=null)adjust_tail= link(adjust_tail);
p= link(p);free_node(link(prev_p),small_node_size);
}
else
{link(adjust_tail)= p;adjust_tail= p;p= link(p);
}
link(prev_p)= p;p= prev_p;
}
break;
case whatsit_node:
if(subtype(p)==graf_node)
goto repack;
else if(subtype(p)==disp_node)
goto repack;
else if(subtype(p)==vpack_node)
goto repack;
else if(subtype(p)==hpack_node)
goto repack;
else if(subtype(p)==hset_node)
goto repack;
else if(subtype(p)==vset_node)
goto repack;
else if(subtype(p)==stream_node)
goto repack;
else if(subtype(p)==image_node)
{glue_ord o;
if(image_height(p)>h)h= image_height(p);
x= x+image_width(p);
o= image_stretch_order(p);total_stretch[o]= total_stretch[o]+image_stretch(p);
o= image_shrink_order(p);total_shrink[o]= total_shrink[o]+image_shrink(p);
}
break;
break;
case glue_node:
{glue_ord o;
g= glue_ptr(p);x= x+width(g);
o= stretch_order(g);total_stretch[o]= total_stretch[o]+stretch(g);
o= shrink_order(g);total_shrink[o]= total_shrink[o]+shrink(g);
if(subtype(p)>=a_leaders)
{g= leader_ptr(p);
if(height(g)>h)h= height(g);
if(depth(g)>d)d= depth(g);
}
}
break;
case kern_node:case math_node:x= x+width(p);break;
case ligature_node:
{mem[lig_trick]= mem[lig_char(p)];link(lig_trick)= link(p);
p= lig_trick;goto reswitch;
}
default:do_nothing;
}
p= link(p);
}
}
if(adjust_tail!=null)link(adjust_tail)= null;
height(r)= h;depth(r)= d;
if(total_stretch[filll]!=0)sto= filll;
else if(total_stretch[fill]!=0)sto= fill;
else if(total_stretch[fil]!=0)sto= fil;
else sto= normal;

if(total_shrink[filll]!=0)sho= filll;
else if(total_shrink[fill]!=0)sho= fill;
else if(total_shrink[fil]!=0)sho= fil;
else sho= normal;

if(hf!=0||vf!=0)
{pointer q;
q= new_set_node();
subtype(q)= hset_node;
height(q)= h;
depth(q)= d;
width(q)= x;
shift_amount(q)= shift_amount(r);
list_ptr(q)= list_ptr(r);
list_ptr(r)= null;
free_node(r,box_node_size);
if(m==exactly)
set_extent(q)= new_xdimen(w,hf,vf);
else
set_extent(q)= new_xdimen(x+w,hf,vf);
set_stretch_order(q)= sto;
set_shrink_order(q)= sho;
set_stretch(q)= total_stretch[sto];
set_shrink(q)= total_shrink[sho];
return q;
}




if(m==additional)w= x+w;
width(r)= w;x= w-x;

if(x==0)
{glue_sign(r)= normal;glue_order(r)= normal;
set_glue_ratio_zero(glue_set(r));
goto end;
}
else if(x>0)
{
glue_order(r)= sto;glue_sign(r)= stretching;
if(total_stretch[sto]!=0)glue_set(r)= unfloat(x/(double)total_stretch[sto]);
else
{glue_sign(r)= normal;
set_glue_ratio_zero(glue_set(r));
}
if(sto==normal)
{if(list_ptr(r)!=null)
{last_badness= badness(x,total_stretch[normal]);
if(last_badness>hbadness)
{print_ln();
if(last_badness>100)
print_nl("Underfull");else print_nl("Loose");
print_str(" \\hbox (badness ");print_int(last_badness);
goto common_ending;
}
}
}
goto end;
}
else
{
glue_order(r)= sho;glue_sign(r)= shrinking;
if(total_shrink[sho]!=0)
glue_set(r)= unfloat((-x)/(double)total_shrink[sho]);
else
{glue_sign(r)= normal;
set_glue_ratio_zero(glue_set(r));
}
if((total_shrink[sho]<-x)&&(sho==normal)&&(list_ptr(r)!=null))
{last_badness= 1000000;
set_glue_ratio_one(glue_set(r));
if((-x-total_shrink[normal]>hfuzz)||(hbadness<100))
{if((overfull_rule>0)&&(-x-total_shrink[normal]>hfuzz))
{while(link(prev_p)!=null)prev_p= link(prev_p);
link(prev_p)= new_rule();
width(link(prev_p))= overfull_rule;
}
print_ln();print_nl("Overfull \\hbox (");
print_scaled(-x-total_shrink[normal]);print_str("pt too wide");
goto common_ending;
}
}
else if(sho==normal)
{if(list_ptr(r)!=null)
{last_badness= badness(-x,total_shrink[normal]);
if(last_badness>hbadness)
{print_ln();print_nl("Tight \\hbox (badness ");print_int(last_badness);
goto common_ending;
}
}
}
goto end;
}
common_ending:
if(pack_begin_line!=0)
{if(pack_begin_line>0)print_str(") in paragraph at lines ");
else print_str(") in alignment at lines ");
print_int(abs(pack_begin_line));
print_str("--");
}
else print_str(") detected at line ");
print_int(line);
print_ln();
font_in_short_display= null_font;short_display(list_ptr(r));print_ln();
begin_diagnostic();show_box(r);end_diagnostic(true);
end:return r;


repack:
{
pointer q;
q= new_pack_node();
height(q)= h;
depth(q)= d;
width(q)= x;
subtype(q)= hpack_node;
list_ptr(q)= list_ptr(r);
list_ptr(r)= null;
free_node(r,box_node_size);
pack_limit(q)= max_dimen;
pack_m(q)= m;
pack_extent(q)= new_xdimen(w,hf,vf);
return q;
}
}

	/*:54*/	/*55:*/
	#line 2152 "hitex.w"

pointer vpackage(pointer p,scaled h,scaled hf,scaled vf,small_number m,scaled l)
{pointer r;
scaled w,d,x;
scaled s= 0;
pointer g;
glue_ord sho,sto;
last_badness= 0;r= get_node(box_node_size);type(r)= vlist_node;
subtype(r)= min_quarterword;shift_amount(r)= 0;
list_ptr(r)= p;
w= 0;
d= 0;x= 0;
total_stretch[normal]= 0;total_shrink[normal]= 0;
total_stretch[fil]= 0;total_shrink[fil]= 0;
total_stretch[fill]= 0;total_shrink[fill]= 0;
total_stretch[filll]= 0;total_shrink[filll]= 0;
while(p!=null)
{if(is_char_node(p))
confusion(519);
else
switch(type(p))
{case hlist_node:case vlist_node:case rule_node:case unset_node:
x= x+d+height(p);d= depth(p);
if(type(p)>=rule_node)s= 0;
else s= shift_amount(p);
if(width(p)+s>w)w= width(p)+s;
break;
case whatsit_node:
if(subtype(p)==graf_node)
goto repack;
else if(subtype(p)==disp_node)
goto repack;
else if(subtype(p)==vpack_node)
goto repack;
else if(subtype(p)==hpack_node)
goto repack;
else if(subtype(p)==hset_node)
goto repack;
else if(subtype(p)==vset_node)
goto repack;
else if(subtype(p)==stream_node)
goto repack;
else if(subtype(p)==image_node)
{glue_ord o;
if(image_width(p)>w)w= image_width(p);
x= x+d+image_height(p);d= 0;
o= image_stretch_order(p);total_stretch[o]= total_stretch[o]+image_stretch(p);
o= image_shrink_order(p);total_shrink[o]= total_shrink[o]+image_shrink(p);
}
break;
case glue_node:
{glue_ord o;
x= x+d;d= 0;
g= glue_ptr(p);x= x+width(g);
o= stretch_order(g);total_stretch[o]= total_stretch[o]+stretch(g);
o= shrink_order(g);total_shrink[o]= total_shrink[o]+shrink(g);
if(subtype(p)>=a_leaders)
{g= leader_ptr(p);
if(width(g)>w)w= width(g);
}
}
break;
case kern_node:
x= x+d+width(p);d= 0;
break;
default:do_nothing;
}
p= link(p);
}
width(r)= w;


if(total_stretch[filll]!=0)sto= filll;
else if(total_stretch[fill]!=0)sto= fill;
else if(total_stretch[fil]!=0)sto= fil;
else sto= normal;

if(total_shrink[filll]!=0)sho= filll;
else if(total_shrink[fill]!=0)sho= fill;
else if(total_shrink[fil]!=0)sho= fil;
else sho= normal;

if(hf!=0||vf!=0)
{pointer q;
q= new_set_node();
subtype(q)= vset_node;
width(q)= w;
if(d>l)
{x= x+d-l;depth(r)= l;
}
else depth(r)= d;
height(q)= x;
depth(q)= d;
shift_amount(q)= shift_amount(r);
list_ptr(q)= list_ptr(r);
list_ptr(r)= null;
free_node(r,box_node_size);
if(m==exactly)
set_extent(q)= new_xdimen(h,hf,vf);
else
set_extent(q)= new_xdimen(x+h,hf,vf);
set_stretch_order(q)= sto;
set_shrink_order(q)= sho;
set_stretch(q)= total_stretch[sto];
set_shrink(q)= total_shrink[sho];
return q;
}

if(d>l)
{x= x+d-l;depth(r)= l;
}
else depth(r)= d;
if(m==additional)
h= x+h;
height(r)= h;x= h-x;
if(x==0)
{glue_sign(r)= normal;glue_order(r)= normal;
set_glue_ratio_zero(glue_set(r));
goto end;
}
else if(x>0)
{glue_order(r)= sto;glue_sign(r)= stretching;
if(total_stretch[sto]!=0)glue_set(r)= unfloat(x/(double)total_stretch[sto]);
else
{glue_sign(r)= normal;
set_glue_ratio_zero(glue_set(r));
}
if(sto==normal)
{if(list_ptr(r)!=null)
{last_badness= badness(x,total_stretch[normal]);
if(last_badness>vbadness)
{print_ln();
if(last_badness>100)print_nl("Underfull");else print_nl("Loose");
print_str(" \\vbox (badness ");print_int(last_badness);
goto common_ending;
}
}
}
goto end;
}
else
{
glue_order(r)= sho;glue_sign(r)= shrinking;
if(total_shrink[sho]!=0)glue_set(r)= unfloat((-x)/(double)total_shrink[sho]);
else
{glue_sign(r)= normal;
set_glue_ratio_zero(glue_set(r));
}
if((total_shrink[sho]<-x)&&(sho==normal)&&(list_ptr(r)!=null))
{last_badness= 1000000;
set_glue_ratio_one(glue_set(r));
if((-x-total_shrink[normal]>vfuzz)||(vbadness<100))
{print_ln();print_nl("Overfull \\vbox (");
print_scaled(-x-total_shrink[normal]);print_str("pt too high");
goto common_ending;
}
}
else if(sho==normal)
{if(list_ptr(r)!=null)
{last_badness= badness(-x,total_shrink[normal]);
if(last_badness>vbadness)
{print_ln();print_nl("Tight \\vbox (badness ");print_int(last_badness);
goto common_ending;
}
}
}
goto end;
}


common_ending:
if(pack_begin_line!=0)
{print_str(") in alignment at lines ");
print_int(abs(pack_begin_line));
print_str("--");
}
else
print_str(") detected at line ");
print_int(line);
print_ln();

begin_diagnostic();show_box(r);end_diagnostic(true);
end:
return r;


repack:
{
pointer q;
q= new_pack_node();
subtype(q)= vpack_node;
height(q)= x;
depth(q)= d;
width(q)= w;
list_ptr(q)= list_ptr(r);
list_ptr(r)= null;
free_node(r,box_node_size);
pack_limit(q)= l;
pack_m(q)= m;
pack_extent(q)= new_xdimen(h,hf,vf);
return q;
}
}

	/*:55*/	/*57:*/
	#line 2382 "hitex.w"

int hget_stream_no(int i)
{static bool init= false;
int s;
if(i==0)return 0;
s= insert2stream[i];
if(s!=0)return s;
if(!init)
{pointer t,s;
for(t= link(setpage_head);t!=null;t= link(t))
for(s= setpage_streams(t);s!=null;s= link(s))
insert2stream[setstream_insertion(s)]= setstream_number(s);
max_ref[stream_kind]= max_stream;
init= true;
}
s= insert2stream[i];
if(s==0)
s= insert2stream[i]= max_ref[stream_kind]= ++max_stream;
return s;
}
	/*:57*/	/*58:*/
	#line 2443 "hitex.w"

pointer new_setstream_node(uint8_t n)
{pointer p= get_node(setstream_node_size);
type(p)= whatsit_node;subtype(p)= setstream_node;
setstream_insertion(p)= n;
setstream_number(p)= hget_stream_no(n);
setstream_mag(p)= 1000;
setstream_prefered(p)= 255;
setstream_next(p)= 255;
setstream_ratio(p)= 0;
setstream_max(p)= new_xdimen(0,0,ONE);
setstream_width(p)= new_xdimen(0,ONE,0);
setstream_topskip(p)= zero_glue;add_glue_ref(zero_glue);
setstream_height(p)= zero_glue;add_glue_ref(zero_glue);
setstream_before(p)= null;
setstream_after(p)= null;

return p;
}
	/*:58*/	/*59:*/
	#line 2478 "hitex.w"

void hfinish_stream_group(void)
{pointer s;
end_graf();
s= hget_current_stream();
if(s!=null)
{pointer t;
uint8_t i;
i= setstream_insertion(s);
setstream_mag(s)= count(i);
setstream_width(s)= new_xdimen(dimen_par(hsize_code),
dimen_par_hfactor(hsize_code),dimen_par_vfactor(hsize_code));
t= zero_glue;add_glue_ref(t);delete_glue_ref(setstream_topskip(s));setstream_topskip(s)= t;
t= skip(i);add_glue_ref(t);delete_glue_ref(setstream_height(s));setstream_height(s)= t;
setstream_max(s)= new_xdimen(dimen(i),
dimen_hfactor(i),dimen_vfactor(i));
}
unsave();
flush_node_list(link(head));
pop_nest();
}
	/*:59*/	/*60:*/
	#line 2506 "hitex.w"

void hfinish_stream_before_group(void)
{pointer s;
end_graf();
s= hget_current_stream();
if(s!=null)
setstream_before(s)= link(head);
unsave();
pop_nest();
}

void hfinish_stream_after_group(void)
{pointer s;
end_graf();
s= hget_current_stream();
if(s!=null)
setstream_after(s)= link(head);
unsave();
pop_nest();
}
	/*:60*/	/*61:*/
	#line 2565 "hitex.w"

pointer new_setpage_node(uint8_t i,str_number n)
{pointer p,prev_p;
prev_p= setpage_head;
for(p= link(prev_p);p!=null;prev_p= p,p= link(p))
if(setpage_id(p)==i)break;
if(p==null)
	/*62:*/
	#line 2581 "hitex.w"

{p= get_node(setpage_node_size);type(p)= whatsit_node;subtype(p)= setpage_node;
setpage_number(p)= max_ref[page_kind]= ++max_page;
setpage_id(p)= i;
setpage_name(p)= n;
setpage_priority(p)= 1;
setpage_topskip(p)= zero_glue;add_glue_ref(zero_glue);
setpage_height(p)= new_xdimen(0,0,ONE);
setpage_width(p)= new_xdimen(0,ONE,0);
setpage_depth(p)= max_depth;
setpage_list(p)= null;
setpage_streams(p)= null;
}
	/*:62*/
	#line 2572 "hitex.w"

else
link(prev_p)= link(p);
link(p)= link(setpage_head);
link(setpage_head)= p;
return p;
}
	/*:61*/	/*63:*/
	#line 2601 "hitex.w"

void hfinish_page_group(void)
{uint8_t k;
pointer p,q,r;
end_graf();
p= hget_current_page();
if(p!=null)
{delete_glue_ref(setpage_topskip(p));
setpage_topskip(p)= top_skip;add_glue_ref(top_skip);
setpage_depth(p)= max_depth;
flush_node_list(setpage_list(p));
setpage_list(p)= link(head);
}
unsave();
pop_nest();
}
	/*:63*/	/*65:*/
	#line 2645 "hitex.w"

static void hout_init(void)
{
new_directory(dir_entries);
new_output_buffers();
max_section_no= 2;
hdef_init();
hput_content_start();
	/*135:*/
	#line 4055 "hitex.w"

{uint32_t pos= hpos-hstart;
hpos++;
hput_tags(pos,hout_language(language));
}
	/*:135*/
	#line 2653 "hitex.w"

}

void hint_open(void)
{pack_job_name(make_tex_string(".hnt"));
hout= tl_open_out((const char*)name_of_file+1,"wb");
if(hout==NULL)
{fprintf(stderr,"Unable to open %s\n",name_of_file+1);
exit(1);
}
hlog= stderr;
option_global= true;
hout_init();
}
	/*:65*/	/*66:*/
	#line 2671 "hitex.w"

static void hout_terminate(void)
{hput_content_end();
hput_definitions();
hput_directory();
hput_hint("created by HiTeX Version "HITEX_VERSION);
}

void hint_close(void)
{hout_terminate();
if(hout!=NULL)
fclose(hout);
hout= NULL;
}
	/*:66*/	/*73:*/
	#line 2775 "hitex.w"


void hfix_defaults(void)
{int i;
DBG(DBGDEF,"Freezing HINT file defaults\n");
	/*51:*/
	#line 1879 "hitex.w"

{pointer p;
p= link(setpage_head);
if(p==null)
{scaled margin;
if(hhsize<hvsize)margin= hhsize;else margin= hvsize;
margin= margin/6-6*unity;
if(margin<0)margin= 0;
page_h= hhsize+2*margin;
page_v= hvsize+2*margin;
}
else
{pointer x;
x= setpage_height(p);
page_v= xdimen_width(x)
+round(((double)xdimen_hfactor(x)*hhsize+(double)xdimen_vfactor(x)*hvsize)/unity);
x= setpage_width(p);
page_h= xdimen_width(x)
+round(((double)xdimen_hfactor(x)*hhsize+(double)xdimen_vfactor(x)*hvsize)/unity);
}
}
	/*:51*/
	#line 2780 "hitex.w"

	/*78:*/
	#line 2933 "hitex.w"

int_defined[zero_int_no]= 0;
for(i= pretolerance_code;i<=hang_after_code;i++)
if(hmap_int[i]>=0)int_defined[hmap_int[i]]= int_par(i);
max_ref[int_kind]= MAX_INT_DEFAULT;
	/*:78*/
	#line 2781 "hitex.w"

	/*84:*/
	#line 3023 "hitex.w"

dimen_defined[zero_dimen_no]= 0;
for(i= par_indent_code;i<=emergency_stretch_code;i++)
if(hmap_dimen[i]>=0)dimen_defined[hmap_dimen[i]]= dimen_par(i);
dimen_defined[hsize_dimen_no]= page_h;
dimen_defined[vsize_dimen_no]= page_v;
dimen_defined[quad_no]= quad(cur_font);
dimen_defined[math_quad_no]= math_quad(text_size);
max_ref[dimen_kind]= MAX_DIMEN_DEFAULT;
	/*:84*/
	#line 2782 "hitex.w"

	/*95:*/
	#line 3176 "hitex.w"

glue_defined[zero_skip_no]= zero_glue;incr(glue_ref_count(zero_glue));
for(i= line_skip_code;i<=par_fill_skip_code;i++)
if(hmap_glue[i]>=0)
{glue_defined[hmap_glue[i]]= glue_par(i);incr(glue_ref_count(glue_par(i)));}
max_ref[glue_kind]= MAX_GLUE_DEFAULT;
	/*:95*/
	#line 2783 "hitex.w"

	/*123:*/
	#line 3820 "hitex.w"

max_ref[page_kind]= max_page;
max_ref[stream_kind]= max_stream;
	/*:123*/
	#line 2784 "hitex.w"

}

	/*:73*/	/*74:*/
	#line 2811 "hitex.w"

static void hdef_init(void)
{int i;
	/*53:*/
	#line 1906 "hitex.w"

hsize= 0;vsize= 0;
dimen_par_hfactor(hsize_code)= unity;
dimen_par_vfactor(vsize_code)= unity;
	/*:53*/
	#line 2814 "hitex.w"

	/*88:*/
	#line 3071 "hitex.w"

for(i= 0;i<=max_fixed[xdimen_kind];i++)
{xdimen_defined[i].w= xdimen_defaults[i].w;
xdimen_defined[i].h= ONE*xdimen_defaults[i].h;
xdimen_defined[i].v= ONE*xdimen_defaults[i].v;
}
	/*:88*/
	#line 2815 "hitex.w"

	/*101:*/
	#line 3289 "hitex.w"

bl_allocated= 8;
ALLOCATE(bl_defined,bl_allocated,bl_defined_t);
bl_defined[zero_baseline_no].bs= zero_glue;incr(glue_ref_count(zero_glue));
bl_defined[zero_baseline_no].ls= zero_glue;incr(glue_ref_count(zero_glue));
bl_defined[zero_baseline_no].lsl= 0;
bl_used= MAX_BASELINE_DEFAULT+1;
max_ref[baseline_kind]= MAX_BASELINE_DEFAULT;
	/*:101*/
	#line 2816 "hitex.w"

	/*116:*/
	#line 3635 "hitex.w"

for(i= 0;i<0x100;i++)hmap_font[i]= -1;
max_ref[font_kind]= -1;
	/*:116*/
	#line 2817 "hitex.w"

#if 0
overfull_rule= 0;
#endif
}
	/*:74*/	/*75:*/
	#line 2833 "hitex.w"

static void hput_definitions()

{int i;
uint32_t d,m,s;
hput_definitions_start();
hput_max_definitions();
	/*136:*/
	#line 4068 "hitex.w"

DBG(DBGDEF,"Maximum language reference: %d\n",max_ref[language_kind]);
for(i= max_fixed[language_kind]+1;i<=max_ref[language_kind];i++)
{HPUTNODE;
HPUT8(TAG(language_kind,0));
HPUT8(i);
if(hlanguage[i].s==0)
hput_string("unknown");
else
hout_string(hlanguage[i].s);
HPUT8(TAG(language_kind,0));
}
	/*:136*/
	#line 2840 "hitex.w"

	/*120:*/
	#line 3746 "hitex.w"

{int f;
DBG(DBGDEF,"Defining %d fonts\n",max_ref[font_kind]+1);
for(f= 0;f<=max_ref[font_kind];f++)
{font_t*hf= hfonts[f];
internal_font_number g= hf->i;
uint32_t pos= hpos-hstart;
info_t i= b000;
DBG(DBGDEF,"Defining font %d size 0x%x\n",f,font_size[g]);
hpos++;HPUTNODE;
HPUT8(f);
hout_string(font_id_text(g));
if(font_size[g]>0)HPUT32(font_size[g]);
else HPUT32(font_dsize[g]);
HPUT16(hf->m);HPUT16(hf->y);
DBG(DBGDEF,"Defining font space\n");
HPUTCONTENT(hout_glue_spec,hf->g);
DBG(DBGDEF,"Defining font hyphen\n");
HPUTCONTENT(hout_hyphen,hf->h);
hdef_font_params(hf->p);
DBG(DBGDEF,"End of font %d\n",f);
hput_tags(pos,TAG(font_kind,i));
}
}
	/*:120*/
	#line 2841 "hitex.w"

	/*81:*/
	#line 2978 "hitex.w"

DBG(DBGDEF,"Maximum int reference: %d\n",max_ref[int_kind]);
for(i= max_fixed[int_kind]+1;i<=max_default[int_kind];i++)
{if(int_defined[i]!=int_defaults[i])
HPUTDEF(hput_int(int_defined[i]),i);
}
for(;i<=max_ref[int_kind];i++)
HPUTDEF(hput_int(int_defined[i]),i);
	/*:81*/
	#line 2842 "hitex.w"

	/*86:*/
	#line 3051 "hitex.w"

DBG(DBGDEF,"Maximum dimen reference: %d\n",max_ref[dimen_kind]);
for(i= max_fixed[dimen_kind]+1;i<=max_default[dimen_kind];i++)
{if(dimen_defined[i]!=dimen_defaults[i])
HPUTDEF(hput_dimen(dimen_defined[i]),i);
}
for(;i<=max_ref[dimen_kind];i++)
HPUTDEF(hput_dimen(dimen_defined[i]),i);
	/*:86*/
	#line 2843 "hitex.w"

	/*91:*/
	#line 3118 "hitex.w"

DBG(DBGDEF,"Maximum xdimen reference: %d\n",max_ref[xdimen_kind]);
for(i= max_fixed[xdimen_kind]+1;i<=max_default[xdimen_kind];i++)
{xdimen_t x;
x.w= xdimen_defined[i].w;
x.h= xdimen_defined[i].h/(double)ONE;
x.v= xdimen_defined[i].v/(double)ONE;

if(x.w!=xdimen_defaults[i].w||
x.h!=xdimen_defaults[i].h||
x.v!=xdimen_defaults[i].v)
HPUTDEF(hput_xdimen(&x),i);
}
for(;i<=max_ref[xdimen_kind];i++)
{xdimen_t x;
x.w= xdimen_defined[i].w;
x.h= xdimen_defined[i].h/(double)ONE;
x.v= xdimen_defined[i].v/(double)ONE;
HPUTDEF(hput_xdimen(&x),i);
}
	/*:91*/
	#line 2844 "hitex.w"

	/*98:*/
	#line 3246 "hitex.w"

DBG(DBGDEF,"Maximum glue reference: %d\n",max_ref[glue_kind]);
for(i= max_fixed[glue_kind]+1;i<=max_default[glue_kind];i++)
{glue_t g;
to_glue_t(glue_defined[i],&g);
if(!glue_t_equal(&g,&glue_defaults[i]))
HPUTDEF(hput_glue(&g),i);
}
for(;i<=max_ref[glue_kind];i++)
HPUTDEF(hout_glue_spec(glue_defined[i]),i);
	/*:98*/
	#line 2845 "hitex.w"

	/*104:*/
	#line 3370 "hitex.w"

DBG(DBGDEF,"Defining %d baseline skips\n",max_ref[baseline_kind]);
for(i= 1;i<=max_ref[baseline_kind];i++)
{uint32_t pos= hpos-hstart;
uint8_t tag;
hpos++;
HPUT8(i);
tag= hout_baselinespec(i);
hstart[pos]= tag;
HPUT8(tag);
}
	/*:104*/
	#line 2846 "hitex.w"

	/*114:*/
	#line 3571 "hitex.w"

DBG(DBGDEF,"Defining %d parameter lists\n",max_ref[param_kind]+1);
for(i= pl_head;i>=0;i= pl_defined[i].l)
{int j;
DBG(DBGDEF,"Defining parameter list %d, size 0x%x\n",i,pl_defined[i].s);
j= hsize_bytes(pl_defined[i].s);
HPUTX(1+1+j+1+pl_defined[i].s+1+j+1);
HPUTTAG(param_kind,j+1);
HPUT8(pl_defined[i].n);
hput_list_size(pl_defined[i].s,j);
HPUT8(0x100-j);
memcpy(hpos,pl_defined[i].p,pl_defined[i].s);
hpos= hpos+pl_defined[i].s;
HPUT8(0x100-j);
hput_list_size(pl_defined[i].s,j);
HPUTTAG(param_kind,j+1);
}
	/*:114*/
	#line 2847 "hitex.w"

	/*110:*/
	#line 3467 "hitex.w"

DBG(DBGDEF,"Maximum hyphen reference: %d\n",max_ref[hyphen_kind]);
for(i= 0;i<=max_ref[hyphen_kind];i++)
HPUTDEF(hout_hyphen(hy_defined[i]),i);
	/*:110*/
	#line 2848 "hitex.w"

	/*125:*/
	#line 3840 "hitex.w"

DBG(DBGDEF,"Maximum page template reference: %d\n",max_page);
{pointer t;
for(t= link(setpage_head);t!=null;t= link(t))
{uint32_t pos= hpos-hstart;
DBG(DBGDEF,"Defining page template %d\n",setpage_number(i));
hpos++;HPUTNODE;
HPUT8(setpage_number(t));
hout_string(setpage_name(t));
HPUT8(setpage_priority(t));
hout_glue_node(setpage_topskip(t));
hput_dimen(setpage_depth(t));
hout_xdimen_node(setpage_height(t));
hout_xdimen_node(setpage_width(t));
hout_list_node2(setpage_list(t));
	/*126:*/
	#line 3863 "hitex.w"

{pointer p,q;
p= setpage_streams(t);
while(p!=null)
{uint8_t n;
n= setstream_number(p);
DBG(DBGDEF,"Defining stream %d at "SIZE_F"\n",n,hpos-hstart);
HPUTTAG(stream_kind,b100);
HPUT8(n);
hout_xdimen_node(setstream_max(p));
HPUT16(setstream_mag(p));
HPUT8(setstream_prefered(p));
HPUT8(setstream_next(p));
HPUT16(setstream_ratio(p));
q= setstream_before(p);setstream_before(p)= null;
hout_list_node2(q);flush_node_list(q);
hout_xdimen_node(setstream_width(p));
q= setstream_topskip(p);
hout_glue_node(q);delete_glue_ref(q);
q= setstream_after(p);setstream_after(p)= null;
hout_list_node2(q);flush_node_list(q);
q= setstream_height(p);
hout_glue_node(q);delete_glue_ref(q);
HPUTTAG(stream_kind,b100);
p= link(p);
}
}
	/*:126*/
	#line 3855 "hitex.w"

hput_tags(pos,TAG(page_kind,0));
}
}
	/*:125*/
	#line 2849 "hitex.w"

hput_definitions_end();
hput_range_defs();
}
	/*:75*/	/*90:*/
	#line 3106 "hitex.w"

pointer new_xdimen(scaled w,scaled h,scaled v)
{pointer p= get_node(xdimen_node_size);
type(p)= whatsit_node;subtype(p)= xdimen_node;
xdimen_width(p)= w;
xdimen_hfactor(p)= h;
xdimen_vfactor(p)= v;
return p;
}
	/*:90*/	/*97:*/
	#line 3213 "hitex.w"

static int hget_glue_no(pointer p)
{static int rover= 0;
int i;
if(p==zero_glue)return zero_skip_no;
for(i= 0;i<=max_ref[glue_kind];i++)
{if(p==glue_defined[rover])return rover;
else if(rover==0)
rover= max_ref[glue_kind];
else
rover--;
}
for(i= 0;i<=max_ref[glue_kind];i++)
{pointer q= glue_defined[rover];
if(glue_spec_equal(p,q))
return rover;
else if(rover==0)
rover= max_ref[glue_kind];
else
rover--;
}
if(max_ref[glue_kind]<0xFF&&section_no==2)
{rover= ++max_ref[glue_kind];
glue_defined[rover]= p;
incr(glue_ref_count(p));
DBG(DBGDEF,"Defining new glue %d\n",rover);
return rover;
}
else
return-1;
}
	/*:97*/	/*102:*/
	#line 3299 "hitex.w"

int hget_baseline_no(pointer bs,pointer ls,scaled lsl)
{
static int rover= 0;
int i;
for(i= 0;i<bl_used;i++)
{bl_defined_t*q= &(bl_defined[rover]);
if(glue_equal(bs,q->bs)&&glue_equal(ls,q->ls)&&lsl==q->lsl)
return rover;
else if(rover==0)
rover= bl_used-1;
else
rover--;
}
if(bl_used>=bl_allocated)
RESIZE(bl_defined,bl_allocated,bl_defined_t);
rover= bl_used++;
if(rover<0x100&&section_no==2)max_ref[baseline_kind]= rover;
if(glue_equal(bs,zero_glue))
{bl_defined[rover].bs= zero_glue;incr(glue_ref_count(zero_glue));}
else
{bl_defined[rover].bs= bs;incr(glue_ref_count(bs));}
if(glue_equal(ls,zero_glue))
{bl_defined[rover].ls= zero_glue;incr(glue_ref_count(zero_glue));}
else
{bl_defined[rover].ls= ls;incr(glue_ref_count(ls));}
bl_defined[rover].lsl= lsl;
return rover;
}

	/*:102*/	/*105:*/
	#line 3384 "hitex.w"

void print_baseline_skip(int i)
{if(0<=i&&i<bl_used)
{print_spec(bl_defined[i].bs,0);print_char(',');
print_spec(bl_defined[i].ls,0);print_char(',');
print_scaled(bl_defined[i].lsl);
}
else
print_str("unknown");
}
	/*:105*/	/*108:*/
	#line 3431 "hitex.w"

int hget_hyphen_no(pointer p)
{
static int rover= 0;
int i;
for(i= 0;i<=max_ref[hyphen_kind];i++)
{pointer q= hy_defined[rover];
if(is_auto_disc(p)==is_auto_disc(q)&&replace_count(p)==replace_count(q)&&
list_equal(pre_break(p),pre_break(q))&&
list_equal(post_break(p),post_break(q)))
return rover;
else if(rover==0)
rover= max_ref[hyphen_kind];
else
rover--;
}
if(max_ref[hyphen_kind]>=0xFF||section_no!=2)return-1;

rover= ++max_ref[hyphen_kind];
hy_defined[rover]= copy_disc_node(p);
	/*109:*/
	#line 3461 "hitex.w"

ensure_font_no(pre_break(p));
ensure_font_no(post_break(p));
	/*:109*/
	#line 3451 "hitex.w"

return rover;
}
	/*:108*/	/*112:*/
	#line 3498 "hitex.w"


static uint32_t hparam_list_hash(list_t*l)
{uint32_t h= 0;
uint32_t i;
for(i= 0;i<l->s;i++)
h= 3*h+hstart[l->p+i];
return i;
}

static bool pl_equal(list_t*l,uint8_t*p)
{uint8_t*q= hstart+l->p;
uint32_t i;
for(i= 0;i<l->s;i++)
if(q[i]!=p[i])return false;
return true;
}

static void pl_copy(list_t*l,uint8_t*p)
{uint8_t*q= hstart+l->p;
memcpy(p,q,l->s);
}

int hget_param_list_no(list_t*l)
{uint32_t h;
int i;
if(l->s<=0)return-1;
h= hparam_list_hash(l);
i= h%PLH_SIZE;
while(pl_defined[i].p!=NULL)
{if(pl_defined[i].h==h&&pl_equal(l,pl_defined[i].p))
return pl_defined[i].n;
i= i+199;
if(i>=PLH_SIZE)i= i-PLH_SIZE;
}
if(max_ref[param_kind]>=0xFF||section_no!=2)return-1;
pl_defined[i].n= ++max_ref[param_kind];
*pl_tail= i;pl_tail= &(pl_defined[i].l);
pl_defined[i].l= -1;
pl_defined[i].h= h;
pl_defined[i].s= l->s;
ALLOCATE(pl_defined[i].p,l->s,uint8_t);
pl_copy(l,pl_defined[i].p);
return pl_defined[i].n;
}
	/*:112*/	/*113:*/
	#line 3548 "hitex.w"

void hdef_param_node(int ptype,int pnumber,int pvalue)
{
if(ptype==int_type)
{if(pvalue==int_defined[hmap_int[pnumber]])return;
else HPUTDEF(hput_int(pvalue),hmap_int[pnumber]);
}
else if(ptype==dimen_type)
{if(pvalue==dimen_defined[hmap_dimen[pnumber]])return;
else HPUTDEF(hput_dimen(pvalue),hmap_dimen[pnumber]);
}
else if(ptype==glue_type)
{if(glue_equal(pvalue,glue_defined[hmap_glue[pnumber]]))return;
else HPUTDEF(hout_glue_spec((pointer)pvalue),hmap_glue[pnumber]);
}
else QUIT("Unexpected parameter type %d",ptype);
}
	/*:113*/	/*127:*/
	#line 3900 "hitex.w"


void hout_node(pointer p)
{uint32_t pos= hpos-hstart;
uint8_t tag;
HPUTNODE;
hpos++;
if(is_char_node(p))
	/*128:*/
	#line 3936 "hitex.w"

{glyph_t g;
g.f= hget_font_no(font(p));
g.c= character(p);
tag= hput_glyph(&g);
}
	/*:128*/
	#line 3908 "hitex.w"

else switch(type(p))
{	/*129:*/
	#line 3948 "hitex.w"

case penalty_node:
{int n,i;
i= penalty(p);
if(i>10000)i= 10000;
else if(i<-10000)i= -10000;
n= hget_int_no(i);
if(n<0)tag= hput_int(i);
else{HPUT8(n);tag= TAG(penalty_kind,0);}
}
break;
	/*:129*/	/*130:*/
	#line 3963 "hitex.w"

case kern_node:
{int n;
n= hget_dimen_no(width(p));
if(n<0)
{kern_t k;
k.x= (subtype(p)==explicit);
k.d.w= width(p);
k.d.h= k.d.v= 0.0;
tag= hput_kern(&k);
}
else
{HPUT8(n);
if(subtype(p)==explicit)tag= TAG(kern_kind,b100);else tag= TAG(kern_kind,b000);
}
}
break;
	/*:130*/	/*137:*/
	#line 4090 "hitex.w"

case math_node:
{kern_t k;
k.x= true;
k.d.w= width(p);
k.d.h= k.d.v= 0.0;
if(subtype(p)==before)
{tag= TAG(math_kind,b111);
if(width(p)!=0)
{hput_tags(pos,hput_kern(&k));
pos= hpos-hstart;
HPUTNODE;
hpos++;
}
}
else
{tag= TAG(math_kind,b011);
if(width(p)!=0)
{hput_tags(pos,tag);
pos= hpos-hstart;
HPUTNODE;
hpos++;
tag= hput_kern(&k);
}
}
}
break;
	/*:137*/	/*139:*/
	#line 4156 "hitex.w"

case glue_node:
if(subtype(p)<cond_math_glue)
tag= hout_glue(glue_ptr(p));
else if(a_leaders<=subtype(p)&&subtype(p)<=x_leaders)
{hout_glue_node(glue_ptr(p));
hout_node(leader_ptr(p));
tag= TAG(leaders_kind,subtype(p)-a_leaders+1);
}
else
QUIT("glue subtype %d not implemented\n",subtype(p));
break;
	/*:139*/	/*141:*/
	#line 4203 "hitex.w"

case disc_node:
{int n;
n= hget_hyphen_no(p);
if(n<0)
tag= hout_hyphen(p);
else{HPUT8(n);tag= TAG(hyphen_kind,0);}
}
break;
	/*:141*/	/*142:*/
	#line 4218 "hitex.w"

case ligature_node:
{lig_t l;
pointer q;
l.f= hget_font_no(font(lig_char(p)));
HPUT8(l.f);
l.l.p= hpos-hstart;
hput_utf8(qo(character(lig_char(p))));
q= lig_ptr(p);
while(q>null)
{hput_utf8(qo(character(q)));
q= link(q);
}
l.l.s= (hpos-hstart)-l.l.p;
tag= hput_ligature(&l);
}
break;
	/*:142*/	/*143:*/
	#line 4237 "hitex.w"

case rule_node:
{rule_t r;
if(is_running(height(p)))r.h= RUNNING_DIMEN;else r.h= height(p);
if(is_running(depth(p)))r.d= RUNNING_DIMEN;else r.d= depth(p);
if(is_running(width(p)))r.w= RUNNING_DIMEN;else r.w= width(p);
tag= hput_rule(&r);
}
break;
	/*:143*/	/*144:*/
	#line 4249 "hitex.w"

case hlist_node:
case vlist_node:
if(type(p)==hlist_node)tag= TAG(hbox_kind,0);
else tag= TAG(vbox_kind,0);
tag|= hput_box_dimen(height(p),depth(p),width(p));
tag|= hput_box_shift(shift_amount(p));
tag|= hput_box_glue_set((glue_sign(p)==stretching)?+1:-1,glue_set(p),glue_order(p));
hout_list_node2(list_ptr(p));
break;
	/*:144*/	/*145:*/
	#line 4262 "hitex.w"

case adjust_node:
{list_t l;
l.k= adjust_kind;
HPUT8(0);
tag= hout_list(adjust_ptr(p),pos+1,&l);
}
break;
	/*:145*/	/*146:*/
	#line 4276 "hitex.w"

case ins_node:
	/*147:*/
	#line 4296 "hitex.w"

{int k,n;
uint32_t pos;
list_t l;
info_t i= b000;
k= subtype(p);
n= hget_stream_no(k);
HPUT8(n);
link(temp_head)= null;
add_par_node(int_type,floating_penalty_code,float_cost(p));
add_par_node(dimen_type,split_max_depth_code,depth(p));
add_par_node(glue_type,split_top_skip_code,split_top_ptr(p));
pos= hpos-hstart;
l.k= param_kind;
n= hout_param_list(link(temp_head),pos,&l);
flush_node_list(link(temp_head));link(temp_head)= null;
if(n>=0)HPUT8(n);else i= b010;
hout_list_node2(ins_ptr(p));
tag= TAG(stream_kind,i);
}
	/*:147*/
	#line 4278 "hitex.w"

break;
	/*:146*/	/*148:*/
	#line 4322 "hitex.w"

case mark_node:hpos--;return;
	/*:148*/	/*149:*/
	#line 4329 "hitex.w"

case whatsit_node:
switch(subtype(p))
{	/*124:*/
	#line 3832 "hitex.w"

case stream_node:
HPUT8(setstream_number(p));
tag= TAG(stream_kind,b100);
break;
	/*:124*/	/*134:*/
	#line 4045 "hitex.w"

case language_node:
tag= hout_language(what_lang(p));
break;
	/*:134*/	/*150:*/
	#line 4349 "hitex.w"

case open_node:
case write_node:
case close_node:
case special_node:hpos--;return;
	/*:150*/	/*151:*/
	#line 4358 "hitex.w"

case graf_node:
{uint32_t pos;
list_t l;
int n;
info_t i= b000;
n= graf_extent(p);
if(hout_xdimen(n))i|= b100;
pos= hpos-hstart;
l.k= param_kind;
n= hout_param_list(graf_params(p),pos,&l);
if(n>=0)HPUT8(n);else i|= b010;
pos= hpos-hstart;
l.k= list_kind;
hout_list_node(graf_list(p),pos,&l);
tag= TAG(par_kind,i);
}
break;
	/*:151*/	/*152:*/
	#line 4379 "hitex.w"

case baseline_node:
{int n;
n= baseline_node_no(p);
if(n>0xFF)tag= hout_baselinespec(n);
else
{HPUT8(n);
tag= TAG(baseline_kind,b000);
}
}
break;
	/*:152*/	/*153:*/
	#line 4393 "hitex.w"

case disp_node:
{uint32_t pos;
list_t l;
int n;
info_t i= b000;
pos= hpos-hstart;
l.k= param_kind;
n= hout_param_list(display_params(p),pos,&l);
if(n>=0)HPUT8(n);else i|= b100;
if(display_eqno(p)!=null&&display_left(p))
{hout_node(display_eqno(p));i|= b010;}
pos= hpos-hstart;
l.k= list_kind;
hout_list_node(display_formula(p),pos,&l);
if(display_eqno(p)!=null&&!display_left(p))
{hout_node(display_eqno(p));i|= b001;}
tag= TAG(math_kind,i);

}
break;
	/*:153*/	/*154:*/
	#line 4423 "hitex.w"

case hset_node:
case vset_node:
{kind_t k= subtype(p)==hset_node?hset_kind:vset_kind;
info_t i= b000;
stretch_t s;
int n= set_extent(p);
if(hout_xdimen(n))i|= b001;
i|= hput_box_dimen(height(p),depth(p),width(p));
i|= hput_box_shift(shift_amount(p));
s.f= set_stretch(p)/(double)ONE;s.o= set_stretch_order(p);
hput_stretch(&s);
s.f= set_shrink(p)/(double)ONE;s.o= set_shrink_order(p);
hput_stretch(&s);
hout_list_node2(list_ptr(p));
tag= TAG(k,i);
}
break;
	/*:154*/	/*155:*/
	#line 4443 "hitex.w"

case hpack_node:
case vpack_node:
{kind_t k= (subtype(p)==hpack_node?hpack_kind:vpack_kind);
info_t i= b000;
int n= pack_extent(p);
if(hout_xdimen(n))i|= b100;
if(pack_m(p)==additional)i|= b001;
if(shift_amount(p)!=0){HPUT32(shift_amount(p));i|= b010;}
if(k==vpack_kind)HPUT32(pack_limit(p));
hout_list_node2(list_ptr(p));
tag= TAG(k,i);
}
break;
	/*:155*/	/*156:*/
	#line 4460 "hitex.w"

case align_node:
{info_t i= b000;
if(align_m(p)==additional)i|= b001;
if(align_v(p))i|= b010;
if(hout_xdimen(align_extent(p)))i|= b100;
hout_preamble(align_preamble(p));
hout_align_list(align_list(p),align_v(p));
tag= TAG(table_kind,i);
}
break;
	/*:156*/	/*160:*/
	#line 4578 "hitex.w"

case image_node:
{image_t i;
i.n= image_no(p);
i.w= image_width(p);
i.h= image_height(p);
i.p.f= image_stretch(p)/(double)ONE;
i.p.o= image_stretch_order(p);
i.m.f= image_shrink(p)/(double)ONE;
i.m.o= image_shrink_order(p);
tag= hput_image(&i);
}
break;
	/*:160*/
	#line 4332 "hitex.w"

default:
MESSAGE("\nOutput of whatsit nodes subtype=%d not implemented\n",subtype(p));
display_node(p);
MESSAGE("End of node");
hpos--;
return;
}
break;
	/*:149*/	/*159:*/
	#line 4569 "hitex.w"

case unset_node:
case unset_set_node:
case unset_pack_node:


	/*:159*/
	#line 3910 "hitex.w"

default:
MESSAGE("\nOutput of node type=%d subtype=%d not implemented\n",type(p),subtype(p));
display_node(p);
MESSAGE("End of node");
hpos--;
return;
}
hput_tags(pos,tag);
}
	/*:127*/	/*161:*/
	#line 4600 "hitex.w"


static uint8_t hout_list(pointer p,uint32_t pos,list_t*l)
{l->p= hpos-hstart;
while(p>mem_min)
{hout_node(p);
p= link(p);
}
l->s= (hpos-hstart)-l->p;
return hput_list(pos,l);
}

static void hout_list_node(pointer p,uint32_t pos,list_t*l)





{
hpos= hstart+pos;
HPUTX(3);
HPUT8(0);
HPUT8(0);
HPUT8(0);
hput_tags(pos,hout_list(p,pos+1,l));
}


static void hout_list_node2(pointer p)
{list_t l;
uint32_t pos;
pos= hpos-hstart;
l.k= list_kind;
hout_list_node(p,pos,&l);
}
	/*:161*/	/*162:*/
	#line 4641 "hitex.w"


static int hout_param_list(pointer p,uint32_t pos,list_t*l)







{int n;
if(p==null)return-1;
hpos= hstart+pos;
HPUTX(3);
HPUT8(0);
HPUT8(0);
HPUT8(0);
l->p= hpos-hstart;
while(p>mem_min)
{hdef_param_node(par_type(p),par_number(p),par_value(p).i);
p= link(p);
}
l->s= (hpos-hstart)-l->p;
n= hget_param_list_no(l);
if(n>=0)
hpos= hstart+pos;
else
hput_tags(pos,hput_list(pos+1,l));
return n;
}
	/*:162*/	/*163:*/
	#line 4678 "hitex.w"


#if 0
static void hchange_text_font(internal_font_number f)
{uint8_t g;
if(f!=hfont)
{g= get_font_no(f);
if(g<8)
hputcc(FONT0_CHAR+g);
else
{hputcc(FONTN_CHAR);
hputcc(g);
}
hfont= f;
}
}

static void hprint_text_char(pointer p)
{uint8_t f,c;
f= font(p);
c= character(p);
hchange_text_font(f);
if(c<=SPACE_CHAR)hputcc(ESC_CHAR);
hputcc(c);
}


static void hprint_text_node(pointer p)
{switch(type(p))
{case hlist_node:

goto nodex;
case glue_node:
if(subtype(p)>=cond_math_glue)goto nodex;
else
{pointer q= glue_ptr(p);
int i;
if(glue_equal(f_space_glue[hfont],q))
{hputc(SPACE_CHAR);return;}
if(glue_equal(f_xspace_glue[hfont],q))
{hputcc(XSPACE_CHAR);return;}
if(f_1_glue[hfont]==0&&(subtype(p)-1==space_skip_code))
{pointer r= glue_par(subtype(p)-1);
add_glue_ref(r);
f_1_glue[hfont]= r;
}
if(f_1_glue[hfont]!=0&&glue_equal(f_1_glue[hfont],q))
{hputcc(GLUE1_CHAR);return;}
if(f_2_glue[hfont]==0&&(subtype(p)-1==space_skip_code||subtype(p)-1==xspace_skip_code))
{pointer r= glue_par(subtype(p)-1);
add_glue_ref(r);
f_2_glue[hfont]= r;
}
if(f_2_glue[hfont]!=0&&glue_equal(f_2_glue[hfont],q))
{hputcc(GLUE2_CHAR);return;}
if(f_3_glue[hfont]==0)
{f_3_glue[hfont]= q;
add_glue_ref(q);
}
if(f_3_glue[hfont]!=0&&glue_equal(f_3_glue[hfont],q))
{hputcc(GLUE3_CHAR);return;}
i= hget_glue_no(q);
if(i>=0)
{hputcc(GLUEN_CHAR);hputcc(i);return;}
}
break;
case ligature_node:
{int n;
pointer q;
for(n= 0,q= lig_ptr(p);n<5&&q!=null;n++,q= link(q))continue;
if(n==2)hputcc(LIG2_CHAR);
else if(n==3)hputcc(LIG3_CHAR);
else if(n==0)hputcc(LIG0_CHAR);
else goto nodex;
hprint_text_char(lig_char(p));
for(q= lig_ptr(p);q!=null;q= link(q))hprint_text_char(q);
return;
}
case disc_node:
if(post_break(p)==null&&pre_break(p)!=null&&replace_count(p)==0)
{pointer q;
q= pre_break(p);
if(is_char_node(q)&&link(q)==null&&font(q)==hfont&&character(q)==hyphen_char[hfont])
{if(is_auto_disc(p))hputcc(DISC1_CHAR);
else hputcc(DISC2_CHAR);
return;
}
}
else if(post_break(p)==null&&pre_break(p)==null&&replace_count(p)==0&&!is_auto_disc(p))
{hputcc(DISC3_CHAR);return;}
break;
case math_node:
if(width(p)!=0)goto nodex;
if(subtype(p)==before)hputcc(MATHON_CHAR);
else hputcc(MATHOFF_CHAR);
return;
default:
break;
}
nodex:
hout_node(p);
}

static void hprint_text(pointer p)
{internal_font_number f= hfont;
nesting++;
hprint_nesting();
hprintf("<text ");
while(p>mem_min)
{if(is_char_node(p))
hprint_text_char(p);
else
hprint_text_node(p);
p= link(p);
}
hchange_text_font(f);
hprintf(">\n");
nesting--;
}
#endif

	/*:163*/
	#line 4833 "hitex.w"


	/*:164*/
