	/*34:*/
	#line 925 "hitex.w"

#include "basetypes.h"
#include "error.h"
#include "hformat.h"
#include "tltex.h"
#include <kpathsea/kpathsea.h>

extern void input_add_arg(char*str);

	/*7:*/
	#line 344 "hitex.w"

int iniversion= 0;
static int parsefirstlinep= -1;
int filelineerrorstylep= -1;
static const char*user_progname= NULL,*output_directory= NULL,*c_job_name= NULL;
char*dump_name= NULL;
#ifdef HITEX
int option_no_empty_page= false,option_hyphen_first= false;
int option_dpi= 600;
const char*option_mfmode= "ljfour",*option_dpi_str= "600";
#endif
	/*:7*/	/*8:*/
	#line 364 "hitex.w"

static struct option long_options[]= {
{"help",0,0,0},
{"version",0,0,0},
{"ini",0,&iniversion,1},
{"progname",1,0,0},
{"fmt",1,0,0},
{"output-directory",1,0,0},
{"jobname",1,0,0},
{"mktex",1,0,0},
{"no-mktex",1,0,0},
{"interaction",1,0,0},
{"kpathsea-debug",1,0,0},
{"parse-first-line",0,&parsefirstlinep,1},
{"no-parse-first-line",0,&parsefirstlinep,0},
{"file-line-error-style",0,&filelineerrorstylep,1},
{"no-file-line-error-style",0,&filelineerrorstylep,0},
{"file-line-error",0,&filelineerrorstylep,1},
{"no-file-line-error",0,&filelineerrorstylep,0},
#ifdef HITEX
{"compress",0,&option_compress,1},
{"no-empty-page",0,&option_no_empty_page,1},
{"hyphenate-first-word",0,&option_hyphen_first,1},
{"resolution",1,0,0},
{"mfmode",1,0,0},
#ifdef DEBUG
{"debug",1,0,0},
#endif
#endif
{0,0,0,0}};
	/*:8*/	/*16:*/
	#line 485 "hitex.w"

static char**argv;
static int argc;
	/*:16*/
	#line 934 "hitex.w"

	/*1:*/
	#line 180 "hitex.w"

static void usage_help(void)
{	/*2:*/
	#line 190 "hitex.w"

fprintf(stderr,
"Usage: %s [OPTION]... [TEXNAME[.tex]] [COMMANDS]\n"
"   or: %s [OPTION]... \\FIRST-LINE\n"
"   or: %s [OPTION]... &FMT ARGS\n\n",
argv[0],argv[0],argv[0]);
fprintf(stderr,
"  Run TeX on TEXNAME. Any remaining COMMANDS are processed\n"
"  as TeX input after TEXNAME is read.\n"
"  If the first line of TEXNAME starts with %%&FMT, and FMT is\n"
"  an existing .fmt file, use it. Else use `NAME.fmt', where\n"
"  NAME is the program invocation name.\n"
"\n"
"  Alternatively, if the first non-option argument begins\n"
"  with a backslash, interpret all non-option arguments as\n"
"  a line of TeX input.\n"
"\n"
"  Alternatively, if the first non-option argument begins\n"
"  with a &, the next word is taken as the FMT to read,\n"
"  overriding all else.  Any remaining arguments are\n"
"  processed as above.\n"
"\n"
"  If no arguments or options are specified, prompt for input.\n"
"\n");

	/*:2*/
	#line 182 "hitex.w"

	/*3:*/
	#line 218 "hitex.w"

fprintf(stderr,
"Options:\n"
" -help                 "
"\t display this help and exit\n"
" -version              "
"\t output version information and exit\n"
" -ini                  "
"\t be initex for dumping formats; this is\n"
"\t\t\t also true if the program name is `(h|c)initex'\n"
" -progname=STRING      "
"\t set program (and fmt) name to STRING\n"
" -fmt=FMTNAME          "
"\t use FMTNAME instead of program name or a %%& line\n"
" -output-directory=DIR "
"\t use DIR as the directory to write files to\n"
" -jobname=STRING       "
"\t set the TeX \\jobname to STRING\n"
" [-no]-mktex=FMT       "
"\t disable/enable mktexFMT generation (FMT=tex/tfm/pk)\n"
" -interaction=STRING   "
"\t set interaction mode (STRING=batchmode/\n"
"\t\t\t nonstopmode/scrollmode/errorstopmode)\n"
" -kpathsea-debug=NUMBER"
"\t set path searching debugging flags according\n"
"\t\t\t to the bits of NUMBER\n"
" [-no]-parse-first-line"
"\t disable/enable parsing of the first line of\n"
"\t\t\t the input file\n"
" [-no]-file-line-error-style\n"
" [-no]-file-line-error"
"\t Disable/Enable file:line:error style\n"
#ifdef HITEX
" -compress             "
"\t enable compression of section 1 and 2\n"
" -no-empty-page        "
"\t suppress empty pages\n"
" -hyphenate-first-word "
"\t hyphenate the first word of a paragraph\n"
" -resolution=NUMBER    "
"\t set the resolution to NUMBER dpi\n"
" -mfmode=MODE          "
"\t set the METAFONT mode to MODE\n"
#endif
);
	/*:3*/	/*4:*/
	#line 266 "hitex.w"

#ifdef DEBUG
#ifdef HITEX
fprintf(stderr,
" -debug=XX             "
"\t XX is a hexadecimal value. OR together these values:\n");
fprintf(stderr,"\t\t\t XX=%04X \t basic debugging\n",DBGBASIC);
fprintf(stderr,"\t\t\t XX=%04X \t tag debugging\n",DBGTAGS);
fprintf(stderr,"\t\t\t XX=%04X \t node debugging\n",DBGNODE);
fprintf(stderr,"\t\t\t XX=%04X \t definition debugging\n",DBGDEF);
fprintf(stderr,"\t\t\t XX=%04X \t directory debugging\n",DBGDIR);
fprintf(stderr,"\t\t\t XX=%04X \t range debugging\n",DBGRANGE);
fprintf(stderr,"\t\t\t XX=%04X \t float debugging\n",DBGFLOAT);
fprintf(stderr,"\t\t\t XX=%04X \t compression debugging\n",DBGCOMPRESS);
fprintf(stderr,"\t\t\t XX=%04X \t buffer debugging\n",DBGBUFFER);
fprintf(stderr,"\t\t\t XX=%04X \t TeX debugging\n",DBGTEX);
fprintf(stderr,"\t\t\t XX=%04X \t page debugging\n",DBGPAGE);
fprintf(stderr,"\t\t\t XX=%04X \t font debugging\n",DBGFONT);
#endif
#endif
	/*:4*/
	#line 183 "hitex.w"

fprintf(stderr,"\nEmail bug reports to ruckert@cs.hm.edu.\n");
exit(0);
}
	/*:1*/	/*5:*/
	#line 294 "hitex.w"

static char*normalize_quotes(const char*name,const char*mesg)
{
bool quoted= false;
bool must_quote= (strchr(name,' ')!=NULL);

char*ret= xmalloc(strlen(name)+3);
char*p= ret;
const char*q;

if(must_quote)
*p++= '"';
for(q= name;*q;q++)
if(*q=='"')
quoted= !quoted;
else
*p++= *q;

if(must_quote)
*p++= '"';
*p= '\0';
if(quoted){
fprintf(stderr,"! Unbalanced quotes in %s %s\n",mesg,name);
exit(1);
}
return ret;
}
	/*:5*/	/*6:*/
	#line 328 "hitex.w"

static void parse_options(int argc,char*argv[])
{while(true){
int option_index;
int g= getopt_long_only(argc,argv,"+",long_options,&option_index);
if(g==0)
{	/*9:*/
	#line 402 "hitex.w"


#define ARGUMENT_IS(X) STREQ(long_options[option_index].name, X)

if(ARGUMENT_IS("help"))usage_help();
else if(ARGUMENT_IS("version")){
printf("Version "HITEX_VERSION"\n");
exit(0);
}
	/*:9*/	/*10:*/
	#line 415 "hitex.w"

else if(ARGUMENT_IS("progname"))user_progname= optarg;
else if(ARGUMENT_IS("fmt"))dump_name= optarg;
else if(ARGUMENT_IS("output-directory"))output_directory= optarg;
else if(ARGUMENT_IS("jobname"))c_job_name= normalize_quotes(optarg,"jobname");
	/*:10*/	/*12:*/
	#line 435 "hitex.w"

else if(ARGUMENT_IS("mktex"))kpse_maketex_option(optarg,true);
else if(ARGUMENT_IS("no-mktex"))kpse_maketex_option(optarg,false);
	/*:12*/	/*13:*/
	#line 445 "hitex.w"

else if(ARGUMENT_IS("interaction")){
if(STREQ(optarg,"batchmode"))interaction= 0;
else if(STREQ(optarg,"nonstopmode"))interaction= 1;
else if(STREQ(optarg,"scrollmode"))interaction= 2;
else if(STREQ(optarg,"errorstopmode"))interaction= 3;
else WARNING1("Ignoring unknown argument `%s' to --interaction",optarg);
}
	/*:13*/	/*14:*/
	#line 458 "hitex.w"

else if(ARGUMENT_IS("kpathsea-debug"))
kpathsea_debug|= atoi(optarg);
	/*:14*/	/*15:*/
	#line 465 "hitex.w"

#ifdef HITEX
else if(ARGUMENT_IS("resolution"))
{option_dpi_str= optarg;
option_dpi= strtol(option_dpi_str,NULL,10);
}
else if(ARGUMENT_IS("mfmode"))
option_mfmode= optarg;
#ifdef DEBUG
else if(ARGUMENT_IS("debug"))
debugflags= strtol(optarg,NULL,16);
#endif
#endif
	/*:15*/
	#line 334 "hitex.w"
}
else if(g==-1)return;
}
}
	/*:6*/	/*20:*/
	#line 546 "hitex.w"

#ifdef WIN32
static void clean_windows_filename(char*filename)
{if(strlen(filename)>2&&isalpha(filename[0])&&
filename[1]==':'&&filename[2]=='\\'){
char*pp;
for(pp= filename;*pp;pp++)
if(*pp=='\\')
*pp= '/';
}
}
#endif

static char*tl_find_file(char*fname,kpse_file_format_type t,bool mx)
{char*filename;
int final_quote= strlen(fname)-1;
bool quoted= final_quote>1&&fname[0]=='"'&&fname[final_quote]=='"';
if(quoted){

fname[final_quote]= '\0';
fname++;
}
filename= kpse_find_file(fname,t,mx);
if(quoted){

fname--;
fname[final_quote]= '"';
}
return filename;
}

static char*get_input_file_name(void)
{
char*input_file_name= NULL;

if(argv[optind]&&argv[optind][0]!='&'&&argv[optind][0]!='\\')
{
#ifdef WIN32
clean_windows_filename(argv[optind]);
#endif
argv[optind]= normalize_quotes(argv[optind],"argument");
input_file_name= tl_find_file(argv[optind],kpse_tex_format,false);
}
return input_file_name;
}
	/*:20*/	/*23:*/
	#line 624 "hitex.w"

static bool texmf_yesno(const char*var)
{
char*value= kpse_var_value(var);
return value&&(*value=='t'||*value=='y'||*value=='1');
}
	/*:23*/	/*25:*/
	#line 675 "hitex.w"

static void parse_first_line(char*filename)
{FILE*f= NULL;
if(filename==NULL)return;
f= tl_open_tex(filename);
if(f!=NULL)
{char*r,*s,*t= read_line(f);
xfclose(f,filename);
if(t==NULL)return;
s= t;
if(s[0]=='%'&&s[1]=='&'){
s= s+2;
while(ISBLANK(*s))++s;
r= s;
while(*s!=0&&*s!=' '&&*s!='\r'&&*s!='\n')s++;
*s= 0;
if(dump_name==NULL){
char*f_name= concat(r,".fmt");
char*d_name= kpse_find_file(f_name,kpse_fmt_format,false);
if(d_name&&kpse_readable_file(d_name)){
dump_name= xstrdup(r);
kpse_reset_program_name(dump_name);
}
free(f_name);
}
}
free(t);
}
}
	/*:25*/	/*28:*/
	#line 757 "hitex.w"

static FILE*tl_open_in(char*filename,kpse_file_format_type t,const char*mode)
{char*fname= NULL;
FILE*f= NULL;
fname= tl_find_file(filename,t,true);
if(fname!=NULL)
{
f= fopen(fname,mode);
free(fname);
}
return f;
}

FILE*tl_open_tex(char*filename)
{return tl_open_in(filename,kpse_tex_format,"r");}

FILE*tl_open_tfm(const char*filename)
{return kpse_open_file(filename,kpse_tfm_format);}

	/*:28*/
	#line 935 "hitex.w"

	/*11:*/
	#line 424 "hitex.w"

int get_job_name(int s)
{if(c_job_name!=NULL)
s= make_tex_string(c_job_name);
return s;
}
	/*:11*/	/*17:*/
	#line 490 "hitex.w"

void tl_maininit(int ac,char*av[])
{
char*main_input_file;
argc= ac;
argv= av;
interaction= 3;
	/*18:*/
	#line 510 "hitex.w"

#if defined(WIN32)
{char*enc;
kpse_set_program_name(argv[0],NULL);
enc= kpse_var_value("command_line_encoding");
get_command_line_args_utf8(enc,&argc,&argv);
parse_options(argc,argv);
}
#else
parse_options(ac,av);
#endif
	/*:18*/
	#line 497 "hitex.w"

	/*19:*/
	#line 525 "hitex.w"

if(!user_progname)
user_progname= dump_name;

#if defined(WIN32)
if(user_progname)
kpse_reset_program_name(user_progname);
#else
kpse_set_program_name(argv[0],user_progname);
#endif
	/*:19*/
	#line 498 "hitex.w"

xputenv("engine","hitex");
	/*21:*/
	#line 597 "hitex.w"

main_input_file= get_input_file_name();

#ifdef WIN32

if(main_input_file==NULL){
char*name= argv[argc-1];
if(name&&name[0]!='-'&&name[0]!='&'&&name[0]!='\\'){
clean_windows_filename(name);
name= normalize_quotes(name,"argument");
main_input_file= tl_find_file(name,kpse_tex_format,false);
argv[argc-1]= name;
}
}
#endif

	/*:21*/
	#line 500 "hitex.w"

	/*22:*/
	#line 617 "hitex.w"

if(filelineerrorstylep<0)
filelineerrorstylep= texmf_yesno("file_line_error_style");
if(parsefirstlinep<0)
parsefirstlinep= texmf_yesno("parse_first_line");
	/*:22*/
	#line 501 "hitex.w"

	/*24:*/
	#line 646 "hitex.w"

if(parsefirstlinep&&!dump_name)
parse_first_line(main_input_file);

if(!main_input_file&&argv[1]&&argv[1][0]=='&')
dump_name= argv[1]+1;

#ifdef HITEX
if(strcmp(kpse_program_name,"hinitex")==0)iniversion= true;
else if(strcmp(kpse_program_name,"hvirtex")==0&&!dump_name)
dump_name= "hitex";
#else
if(strcmp(kpse_program_name,"cinitex")==0)iniversion= true;
else if(strcmp(kpse_program_name,"cvirtex")==0&&!dump_name)
dump_name= "ctex";
#endif

if(!dump_name)
dump_name= kpse_program_name;

if(!dump_name)
{fprintf(stderr,"Unable to determine format name\n");
exit(1);
}
	/*:24*/
	#line 502 "hitex.w"

	/*26:*/
	#line 710 "hitex.w"

kpse_set_program_enabled(kpse_tfm_format,MAKE_TEX_TFM_BY_DEFAULT,
kpse_src_compile);
kpse_set_program_enabled(kpse_tex_format,MAKE_TEX_TEX_BY_DEFAULT,
kpse_src_compile);
kpse_set_program_enabled(kpse_fmt_format,MAKE_TEX_FMT_BY_DEFAULT,
kpse_src_compile);
#ifdef HITEX
kpse_set_program_enabled(kpse_pk_format,MAKE_TEX_PK_BY_DEFAULT,
kpse_src_compile);
xputenv("MAKETEX_BASE_DPI",option_dpi_str);
xputenv("MAKETEX_MODE",option_mfmode);
#endif
	/*:26*/
	#line 503 "hitex.w"

}
	/*:17*/	/*27:*/
	#line 736 "hitex.w"

void input_add_argv(void)
{while(optind<argc)input_add_str(argv[optind++]);
}
	/*:27*/	/*29:*/
	#line 785 "hitex.w"

#ifdef HITEX
char*tl_find_tfm(char*filename)
{char*fname= NULL;
fname= tl_find_file(filename,kpse_tfm_format,true);
if(fname==NULL)
fprintf(stderr,"Unable to find font metric file for font %s\n",filename),exit(1);
return fname;
}

char*tl_find_glyph(char*filename)
{char*fname= NULL;
kpse_glyph_file_type file_ret;
fname= tl_find_file(filename,kpse_type1_format,true);
if(fname==NULL)fname= tl_find_file(filename,kpse_truetype_format,true);
if(fname==NULL)fname= tl_find_file(filename,kpse_opentype_format,true);
if(fname==NULL)fname= kpse_find_glyph(filename,option_dpi,kpse_pk_format,&file_ret);
if(fname==NULL)
fprintf(stderr,"Unable to find glyph data for font %s\n",filename),exit(1);
return fname;
}

#endif
	/*:29*/	/*30:*/
	#line 816 "hitex.w"

FILE*tl_open_fmt(char*file_name)
{FILE*f;
if(file_name!=NULL&&file_name[0]!=0)
{f= tl_open_in(file_name,kpse_fmt_format,"rb");
if(f!=NULL)return f;
}
f= tl_open_in(dump_name,kpse_fmt_format,"rb");
return f;
}

	/*:30*/	/*31:*/
	#line 840 "hitex.w"

FILE*tl_open_out(const char*file_name,const char*file_mode)
{FILE*f= NULL;
char*new_name= NULL;
bool absolute= kpse_absolute_p(file_name,false);
if(absolute)
{f= fopen(file_name,file_mode);
if(f!=NULL)return f;
}
else
{if(output_directory)
{char*new_name= concat3(output_directory,DIR_SEP_STRING,file_name);
f= fopen(new_name,file_mode);
}
if(f==NULL)
{free(new_name);new_name= NULL;
f= fopen(file_name,file_mode);
}
if(f==NULL)
{const char*texmfoutput= kpse_var_value("TEXMFOUTPUT");
if(texmfoutput!=NULL&&texmfoutput[0]!=0)
{new_name= concat3(texmfoutput,DIR_SEP_STRING,file_name);
f= fopen(new_name,file_mode);
if(f==NULL){free(new_name);new_name= NULL;}
}
}
}
if(f!=NULL&&new_name!=NULL)
pack_buffered_name(new_name,0,strlen(new_name)-1);
free(new_name);
return f;
}
	/*:31*/	/*32:*/
	#line 877 "hitex.w"


#include <time.h>
void tl_date_and_time(int*t,int*d,int*m,int*y)
{time_t now= time(NULL);
struct tm*gmt= gmtime(&now);
*t= gmt->tm_hour*60+gmt->tm_min;
*d= gmt->tm_mday;
*m= gmt->tm_mon+1;
*y= gmt->tm_year+1900;
}
	/*:32*/
	#line 936 "hitex.w"

	/*:34*/
